/*###########################################################################
#                                                                           #
#        	  				HTTPNCAgx							#
#                                                                           #
###########################################################################*/
#ifndef __HTTPC_H__
#define __HTTPC_H__

#include <avr/io.h>
#include "../23k256/23k256.h"
#include "w5100.h"

/* HTTPX|Xwb_ACeǗ萔	*/
#define HTTPC_INFO_MAX 255		/* ۑőACe(s)								*/
#define HTTPC_INFO_SIZE ( ( HTTPC_INFO_MAX + 1 ) * 2 )

/* \̒`				*/
typedef struct HTTP_CONNECT_t {
	uint8_t flag;				/* \PbgIvV( 0 or Sn_MR_ND )					*/
	uint8_t ver;				/* HTTPvgRo[W 0:HTTP/1.0  1:HTTP/1.0		*/
	uint16_t defPort;			/* ftHg|[gԍ									*/
	uint8_t useDEFPORT;			/* 0:URL̃|[gԍɏ] 1:delPortɋڑ		*/
	char url[ URL_SIZE + 32 ];	/* ڑURL(֐Iɂ͔j󂳂Ă)				*/
	char command[8];			/* T[o[NGXgR}h "GET"				*/	
	char strRes[16];			/* T[o[Xe[^Xҕ( "HTTP/1.1" "ICY"  )	*/
	char requestMessage[128];	/* T[o[ւ̃NGXgp[^				*/
	SSMP resBuffer;				/* T[o[̃X|Xۑobt@(0:)			*/
	uint16_t resBufferSize;		/* T[o[̃X|Xۑobt@TCY			*/
	uint8_t resCount;			/* T[o[̃X|Xs(MAX255)					*/
} HTTP_CONNECT;

typedef struct HTTPC_INFO_t {
	uint8_t  flag;
	SOCKET   sok;
	uint8_t  step;
	uint16_t line;
	uint16_t len;
	uint16_t resNum;
	uint16_t getRes;
	uint16_t spiSramBufferSize;
	uint16_t lineBufferSize;
	uint16_t port;
	uint32_t ip;
	SSMP idx;
	SSMP p3;
	HTTP_CONNECT cn;
	char msg[512];
} HTTPC_INFO;

/* ֐vg^Cv錾				*/
uint8_t https_connect( SOCKET sok ,HTTP_CONNECT *con ,uint16_t *stsRes );
uint8_t https_connect1( HTTPC_INFO *lp ,SOCKET sok ,HTTP_CONNECT *con );
uint8_t https_connect2( HTTPC_INFO *lp ,uint16_t *stsRes );
void https_cancel( HTTPC_INFO *lp );

#endif
