/*###########################################################################
#                                                                           #
#                    	C[TlbgW[                          #
#                                                                           #
# DHCPLF                                                              #
# \Pbgobt@ Socket0:4K / Socket1:2K / Socket2:1K  Socket3:1K         #
# Socket 3 : NBNSp									                        #
# Socket 2 : NTP^DHCPp         			                                #
# Socket 1 : HTTPSp                                                        #
# Socket 0 : DNSC/HTTPC^Xg[~Op          	                        #
#                                                                           #
# DHCPF                                                              #
# \Pbgobt@ Socket0:8K / Socket1:-- / Socket2:--  Socket3:--         #
# Socket 3 : --									                            #
# Socket 2 : -- 				       		                                #
# Socket 1 : --                                                             #
# Socket 0 : DNS^HTTPC^Xg[~Op                                   #
#                                                                           #
# DHCṔASẴlbg[NT[rX~ɍőeʂ      #
# \PbgOɊ蓖Ă                                                    #
#                                                                           #
###########################################################################*/
#ifndef __NET_H__
#define __NET_H__

/* URLobt@TCY			*/
#define URL_SIZE 256

#include <avr/io.h>

#include "w5100.h"
#include "ntpc.h"
#include "nbns.h"
#include "dnsc.h"
#include "dhcpc.h"
#include "https.h"
#include "httpc.h"
#include "socket.h"
#include "net_util.h"

/* eT[rXŎgp\Pbgԍ	*/
#define NBNS_SOCK  3
#define DHCP_SOCK  2
#define NTPC_SOCK  2
#define HTTPS_SOCK 1
#define DNSC_SOCK  0
#define SHOUT_SOCK 0

/* lbg[Np[^\	*/
typedef struct NET_CONFIG_t {
	char hostname[16];				/* zXgl[(ő15)				*/
	char ntpname[64];				/* NTPT[o[						*/
	uint8_t mac[6];					/* MACAhX							*/
	uint8_t update;					/* lbg[Np[^ύX 0:L 1:	*/
	volatile uint32_t ip;			/* IPAhX							*/
	volatile uint32_t subnet;		/* Tulbg}XN						*/
	volatile uint32_t gateway;		/* Q[gEGCAhX					*/
	volatile uint32_t dns;			/* DNST[o[AhX					*/
	volatile uint32_t ntp;			/* NTPT[o[AhX					*/
	volatile uint8_t dhcpMode;		/* IP擾[h IP_STATIC / IP_DYNAMIC	*/
	volatile uint16_t timeout;		/* ^CAEgJE^					*/
	uint8_t netInit;				/* σtO						*/
} NET_CONFIG;

/* O[oϐ`			*/
#ifndef __NET_C__
extern NET_CONFIG netInfo;
extern DHCP_INFO dhcpInfo;
extern NTPC_INFO ntpcInfo;
#endif

/* ֐vg^Cv錾				*/
void net_timer( void );
void net_init( void );
void net_task( void );

#endif
