/*############################################################################
#                                                                            #
#   		           ~[WbNv[[C						 #
#                                                                            #
############################################################################*/
#define __MENU002_C__
#include "project.h"

#define TIMER_NUM 3
#include "myutil/timer.h"

/* [J֐vg^Cv錾		*/
static void disp_init( void );
static void changePlayMode_AfterPorcess( void );

/*****************************************************************************
*						~[WbNv[[
* Fvoid
* ߒlFvoid
*****************************************************************************/
void menu002( void )
{
	PLAYER_SYS playBuffer;

	/* v[[								*/
	player_init( &playBuffer );

	/* EEPp[^A						*/
	load_player_eep( &playSys->eepInfo );

	/* SPI-SRAMɃt@CL΂Đ		*/
	if ( ss_read_byte( ADDR_pPlayFile ) != '\0' ) {
		char buf[ PLAY_LIST_PATH_LEGNTH + 16 ];
		strcpy_s_SS( buf ,sizeof(buf) ,ADDR_pPlayFile );
		if ( playList_fileItem( &playSys->playList ,buf ) == 0 ) {
			playSys->eepInfo.resume.mode = RESUME_NONE;
			player_play( PLAY_CURRENT );
			playSys->sd_ins = SD_INS();
		}
	}

	/* ʕ\									*/
	disp_init();

	/* C[v									*/
	while ( 1 ) {

		/* VXe^XN							*/
		if ( system_task() != PLAY_STS_NONE ) {
			changePlayMode_AfterPorcess();
		}

		if ( playSys->playMode != PLAY_STS_PAUSE ) {
			/* XyAif[^M					*/
			if ( sys.sp_enable ) {
				g_setSpectrumData( (uint16_t *)sys.dsp_sp );
				sys.sp_enable = 0;
			}

			if ( playSys->tickPlayTime ) {
				playSys->tickPlayTime = 0;

				/* ĐԁEV[No[\			*/
				disp_play_time();

				/* DSPXe[^X\				*/
				disp_dspStatus( 1 );
			}
		}

		if ( ntpcInfo.tickSec ) {
			ntpcInfo.tickSec = 0;

			/* Vbg_E^C}[\			*/
			disp_shutdown_timer();

			/* v\								*/
			disp_clock();
		}

		/* ^b`L[擾							*/
		uint8_t key = g_inkey();
		if ( key == 0 ) {
			continue;
		}

		if ( main_button_process( key ) ) {					/* ʃC		*/
			;

		} else if ( key == BUTTON_FOLDER ) {				/* utH_v			*/
			uint8_t backup_mode = eep.playMode;
			menu100();
			if ( eep.playMode != backup_mode ) {
				break;
			}
			disp_init();

		} else if ( key == BUTTON_REPET ) {					/* us[gv			*/
			disp_play_repet( 1 );
			if ( ++playSys->eepInfo.repetMode >= 3 ) playSys->eepInfo.repetMode = 0;
			WAIT_MS( 50 );
			disp_play_repet( 0 );

		} else if ( key == BUTTON_REV ) {					/* uOȁv				*/
			if ( !( playSys->playMode & PLAY_STS_ERROR_BIT ) ) {
				g_image( 230 ,GMODE ,RGB(0,0,0) ,BUTTON_REV_X ,BUTTON_REV_Y ,BUTTON_REV_X + BUTTON_REV_WIDTH - 1 ,BUTTON_REV_Y + BUTTON_REV_HEIGHT - 1 );
				player_stop();								/* Đ~				*/
				playSys->eepInfo.resume.mode = RESUME_NONE;
				if ( playSys->playTime >= 3 ) {				/* 3bȏĐ?		*/
					player_sound( SOUND_TOP_OF_MUSIC );
					player_play( PLAY_CURRENT );
				} else {
					player_sound( SOUND_BACK_MUSIC );
					player_play( PLAY_BACK );
				}
				changePlayMode_AfterPorcess();
			}

		} else if ( key == BUTTON_FF ) {					/* uȁv				*/
			if ( !( playSys->playMode & PLAY_STS_ERROR_BIT ) ) {
				g_image( 231 ,GMODE ,RGB(0,0,0) ,BUTTON_FF_X ,BUTTON_FF_Y ,BUTTON_FF_X + BUTTON_FF_WIDTH - 1 ,BUTTON_FF_Y + BUTTON_FF_HEIGHT - 1 );
				player_stop();								/* Đ~				*/
				playSys->eepInfo.resume.mode = RESUME_NONE;
				player_sound( SOUND_NEXT_MUSIC );			/* ȑ艹				*/
				player_play( PLAY_NEXT );					/* ̋ȂĐJn		*/
				changePlayMode_AfterPorcess();
			}

		} else if ( key == BUTTON_PLAY ) {					/* uĐv				*/
			if ( !( playSys->playMode & PLAY_STS_ERROR_BIT ) ) {
				/* |[Y	*/
				if ( playSys->playMode == PLAY_STS_PAUSE ) {
					g_image( 228 ,GMODE ,RGB(0,0,0) ,BUTTON_PLAY_X ,BUTTON_PLAY_Y ,BUTTON_PLAY_X + BUTTON_PLAY_WIDTH - 1 ,BUTTON_PLAY_Y + BUTTON_PLAY_HEIGHT - 1 );
					player_sound( SOUND_PAUSE );
					player_play( PLAY_CURRENT );
					g_image( 224 ,GMODE ,RGB(0,0,0) ,BUTTON_PLAY_X ,BUTTON_PLAY_Y ,BUTTON_PLAY_X + BUTTON_PLAY_WIDTH - 1 ,BUTTON_PLAY_Y + BUTTON_PLAY_HEIGHT - 1 );

				/* |[YJn	*/
				} else {
					g_image( 229 ,GMODE ,RGB(0,0,0) ,BUTTON_PLAY_X ,BUTTON_PLAY_Y ,BUTTON_PLAY_X + BUTTON_PLAY_WIDTH - 1 ,BUTTON_PLAY_Y + BUTTON_PLAY_HEIGHT - 1 );
					player_pause();
					player_sound( SOUND_PAUSE );
					g_image( 223 ,GMODE ,RGB(0,0,0) ,BUTTON_PLAY_X ,BUTTON_PLAY_Y ,BUTTON_PLAY_X + BUTTON_PLAY_WIDTH - 1 ,BUTTON_PLAY_Y + BUTTON_PLAY_HEIGHT - 1 );
					memset( (void *)sys.dsp_sp ,0x00 ,sizeof(sys.dsp_sp) );
					g_setSpectrumData( (uint16_t *)sys.dsp_sp );
				}
			}

		} else if ( key == BUTTON_MODE ) {				/* u[h؂ւv		*/
			uint8_t backup_mode = eep.playMode;
			menu101();
			if ( eep.playMode != backup_mode ) {
				break;
			}
			disp_init();

		} else if ( key == BUTTON_SETTING ) {				/* uݒv				*/
			menu102();
			disp_init();

		} else {
			continue;
		}

		g_clearInkey();
	}

	playSys = NULL;
}

/*****************************************************************************
*							ʕ\
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void disp_init( void )
{
	char buf[1];
	buf[0] = '\0';

	g_off();
	g_clearButton();								/* o^{^NA			*/
	g_setSpectrumEnable( 0 );						/* XyAi\XV֎~		*/
	g_textScrollEnable( 0 );						/* ebv\XV֎~		*/
	g_cls();										/* ʃNA				*/
	disp_init_sp();									/* XyAi\		*/
	disp_volume( 0 );								/* ʕ\					*/
	disp_dspStatus( 0 );							/* DSPXe[^X			*/
	disp_play_time();								/* ĐԁEV[No[\	*/
	disp_music_title();								/* ^Cgebv\		*/
	disp_main_menu_buttons( 0x33 );					/* j[{^o^		*/
	disp_play_repet( 0 );							/* s[g{^\		*/
	disp_play_buttons();							/* Đ֌W{^\		*/
	disp_clock();
	disp_shutdown_timer();

	g_addButton( BUTTON_REV ,GMODE ,0 ,BUTTON_REV_X ,BUTTON_REV_Y ,BUTTON_REV_X + BUTTON_REV_WIDTH - 1 ,BUTTON_REV_Y + BUTTON_REV_HEIGHT - 1 ,buf ,0 ,0 );
	g_addButton( BUTTON_PLAY ,GMODE ,0 ,BUTTON_PLAY_X ,BUTTON_PLAY_Y ,BUTTON_PLAY_X + BUTTON_PLAY_WIDTH - 1 ,BUTTON_PLAY_Y + BUTTON_PLAY_HEIGHT - 1 ,buf ,0 ,0 );
	g_addButton( BUTTON_FF ,GMODE ,0 ,BUTTON_FF_X ,BUTTON_FF_Y ,BUTTON_FF_X + BUTTON_FF_WIDTH - 1 ,BUTTON_FF_Y + BUTTON_FF_HEIGHT - 1 ,buf ,0 ,0 );
	g_addButton( BUTTON_REPET ,GMODE ,0 ,BUTTON_REPET_X ,BUTTON_REPET_Y ,BUTTON_REPET_X + BUTTON_REPET_WIDTH - 1 ,BUTTON_REPET_Y + BUTTON_REPET_HEIGHT - 1 ,buf ,0 ,0 );

	g_buttonAllDraw();								/* o^{^\			*/
	g_setSpectrumEnable( 1 );						/* XyAi\XV		*/
	g_on();											/* ʕ\					*/
	g_clearInkey();
}

/*****************************************************************************
*							ĐXe[^XύX̏
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void changePlayMode_AfterPorcess( void )
{
	g_setSpectrumData( (uint16_t *)sys.dsp_sp );
	disp_play_time();
	disp_music_title();
	disp_dspStatus( 0 );
	disp_play_repet( 0 );
	disp_play_buttons();
}
