/*###########################################################################
#                                                                           #
#   @ 				Đt@C̓W[							#
#                                                                           #
###########################################################################*/
#ifndef __GET_PLAY_FILE_INFO_H__
#define __GET_PLAY_FILE_INFO_H__

#include <avr/io.h>

/* Đt@C^Cv`				*/
#define GET_DSP_STATUS_BIT 0x80
#define DO_NOT_JUMP_BIT 0x40
typedef enum {
	 F_OTHER = 0x00											/* T|[gf[^					*/
	,F_MP3 	 = GET_DSP_STATUS_BIT |                   0x01	/* MP3								*/
	,F_WMA 	 = GET_DSP_STATUS_BIT | DO_NOT_JUMP_BIT | 0x02	/* WMA								*/
	,F_AAC	 = GET_DSP_STATUS_BIT | DO_NOT_JUMP_BIT | 0x03	/* AAC								*/
	,F_OGG	 = GET_DSP_STATUS_BIT | DO_NOT_JUMP_BIT | 0x04	/* OGG								*/
	,F_MIDI	 = GET_DSP_STATUS_BIT |                   0x05	/* MIDItH[}bg0				*/
	,F_PCM	 =                      DO_NOT_JUMP_BIT | 0x06	/* jAPCM						*/
	,F_ADPCM = GET_DSP_STATUS_BIT | DO_NOT_JUMP_BIT | 0x07	/* IMA ADPCM						*/
	,F_FMRADIO = 0x08										/* FM-RADIO							*/
	,F_WAVE  = 0x1f											/* WAVE(̒lł͍ĐȂ)		*/
	,F_PLS   = 0x0a											/* PLSt@C						*/
} PLAY_FILE_TYPE;

/* Đt@C\			*/
typedef struct PLAY_FILE_INFO_t {
	PLAY_FILE_TYPE type;						/* t@C									*/
	uint8_t bitsPerSamples;						/* Tvӂ̃rbg						*/
	uint32_t startPos;							/* f[^̊Jnʒu								*/
	uint16_t samplesPerSeconds;					/* TvOg(Hz)						*/
	uint16_t blockSize;							/* 1ubÑoCg(ACg)			*/
	uint16_t bitRate;							/* rbg[g(Kbps)							*/
	union {
		char textBuffer[ LFN_LENGTH + LFN_LENGTH + 16 ];	/* ebveLXgobt@			*/
		struct {
			char author[ LFN_LENGTH + 8 ];					/* ҕꎞobt@			*/
			char title[ LFN_LENGTH + 8 ];					/* Ȗꎞobt@			*/
		} textItem;
	} text;
} PLAY_FILE_INFO;

/* ֐vg^Cv錾				*/
PLAY_FILE_TYPE getVsInfo( uint16_t hdat0 ,uint16_t hdat1 ,uint16_t audata ,uint16_t *bit ,uint16_t *sample );
PLAY_FILE_TYPE getPlayFileType( char *fileName );
uint8_t getPlayFileInfo( char *fileName ,PLAY_FILE_INFO *info );
void clearFileInfo( PLAY_FILE_INFO *info );

#endif
