/*###########################################################################
#                                                                           #
#                 		vCACeXg֌W@@@@@@@@@@@@@@#
#                                                                           #
###########################################################################*/
#ifndef __PLAY_FILE_LIST_H__
#define __PLAY_FILE_LIST_H__

#include <avr/io.h>

#define PLAY_LIST_ITEM_MAX		99				/* XgACeő吔 (MAX 254)				*/
#define PLAY_LIST_PATH_LEGNTH	130				/* fBNgtpXő咷()				*/

/* s[gĐ[h				*/
typedef enum {
	 REPET_NONE	= 0								/* ʏĐ										*/
	,REPET_FILE	= 1								/* ̃t@Cs[g						*/
	,REPET_DIRECTORY = 2						/* fBNgs[g						*/
												/* fBNgɂTufBNg			*/
												/* ɂ͈ړȂ								*/
} REPET_TYPE;

/* vCACe\(14bytes)	*/
typedef struct PLAY_LISTITEM_t {
	char atb;									/*  '0':t@C '1':fBNg			*/
	char fname[13];								/* 8.3`t@C							*/
} PLAY_LISTITEM;

/* vCXg\(1534bytes)	*/
typedef struct PLAYLIST_t {
	uint8_t count;								/* LACe								*/
	uint8_t index;								/* JgACeԍ(0xff:)				*/
	char path[ PLAY_LIST_PATH_LEGNTH + 16 ];	/* JgfBNg						*/
	PLAY_LISTITEM items[ PLAY_LIST_ITEM_MAX ];	/* ACeXg								*/
} PLAYLIST;

/* ֐vg^Cv錾				*/
uint8_t playList_getItemName( PLAYLIST *list ,uint8_t index ,char *fname );
uint8_t playList_fileItem( PLAYLIST *list ,char *fname );
uint8_t playList_findFastItem( PLAYLIST *list );
uint8_t playList_moveNext( PLAYLIST *list ,REPET_TYPE repet ,uint8_t pls );
uint8_t playList_moveBack( PLAYLIST *list ,REPET_TYPE repet ,uint8_t pls );
uint8_t playLIst_moveParents( PLAYLIST *list );
uint8_t playList_moveChild( PLAYLIST *list );
uint8_t playList_loadDir( PLAYLIST *list ,char *pathName );

#endif
