/*############################################################################
#                                                                            #
#   		                  SHCASTWIwb_                         #
#                                                                            #
############################################################################*/
#ifndef __PROJECT_H__
#define __PROJECT_H__

#define VERSION "1.04"

#include <stdio.h>
#include <ctype.h>
#include <string.h> 

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>

#include "W5100/net.h"
#include "myutil/string_func.h"
#include "myutil/crc.h"

#include "FatFs/tff.h"
#include "mmc/mmc.h"
#include "ar1000/ar1000.h"

#include "vs1053b/vs1053b.h"
#include "23k256/23k256.h"

#include "shoutcast.h"
#include "glcd.h"
#include "menu.h"

#include "play_file_list.h"
#include "play_file_info.h"
#include "player.h"

#include "sys_draw.h"

#include "system.h"

/* DEBUGpLED			*/
#define LED_G_ON()  ( PORTF |=  _BV(2) )
#define LED_G_OFF() ( PORTF &= ~_BV(2) )

#define LED_R_ON()  ( PORTF |=  _BV(3) )
#define LED_R_OFF() ( PORTF &= ~_BV(3) )

#endif
