/*############################################################################
#                                                                            #
#   		           ACR^\W[							 #
#                                                                            #
############################################################################*/
#ifndef __SYS_DRAW_H__
#define __SYS_DRAW_H__

#include <avr/io.h>

#define GMODE G_TRANSPARENT
//#define GMODE G_HALF

#define SEEK_VALUE_MAX			   87			/* V[No[ől			*/

/*@{^ԍ`			 		*/
#define BUTTON_VOLUME_UP            1
#define BUTTON_VOLUME_DOWN          2
#define BUTTON_SPEAKER              3
#define BUTTON_MODE                 4
#define BUTTON_FOLDER               5
#define BUTTON_FAVORITES            6
#define BUTTON_SEARCH               7
#define BUTTON_SETTING              8
#define BUTTON_TIMER                9
#define BUTTON_ADD                 10
#define BUTTON_DELETE              11
#define BUTTON_TUNE                12
#define BUTTON_PAGE_UP             13
#define BUTTON_PAGE_DOWN           14
#define BUTTON_CLOSE               15
#define BUTTON_BACK                16
#define BUTTON_REV                 17
#define BUTTON_PLAY                18
#define BUTTON_FF                  19
#define BUTTON_REPET               20
#define BUTTON_CHG_SHOUTCAST       21
#define BUTTON_CHG_PLAYER          22
#define BUTTON_CHG_RADIO           23

#define BUTTON_MAC                 50
#define BUTTON_HOST                51
#define BUTTON_IP                  52
#define BUTTON_SUBNET              53
#define BUTTON_GATEWAY             54
#define BUTTON_DNS                 55
#define BUTTON_NTP                 56
#define BUTTON_DHCP                57

/* {[Abv{^W		*/
#define BUTTON_VOLUME_UP_X        161
#define BUTTON_VOLUME_UP_Y        141
#define BUTTON_VOLUME_UP_WIDTH     48
#define BUTTON_VOLUME_UP_HEIGHT    48

/* {[Abv{^W		*/
#define BUTTON_VOLUME_DOWN_X       53
#define BUTTON_VOLUME_DOWN_Y      141
#define BUTTON_VOLUME_DOWN_WIDTH   48
#define BUTTON_VOLUME_DOWN_HEIGHT  48

/* Xs[J[{^W				*/
#define BUTTON_SPEAKER_X            4
#define BUTTON_SPEAKER_Y          141
#define BUTTON_SPEAKER_WIDTH       48
#define BUTTON_SPEAKER_HEIGHT      48

/* {[Q[WW				*/
#define VOLUME_GAUGE_X            102
#define VOLUME_GAUGE_Y            157
#define VOLUME_GAUGE_WIDTH         58
#define VOLUME_GAUGE_HEIGHT        19

/* XyAiW						*/
#define SPECTRUM_X                214
#define SPECTRUM_Y                154
#define SPECTRUM_WIDTH            101
#define SPECTRUM_HEIGHT            34

/* [h؂ւ{^W			*/
#define BUTTON_MODE_X               3
#define BUTTON_MODE_Y               7
#define BUTTON_MODE_WIDTH          48
#define BUTTON_MODE_HEIGHT         48

/* tH_{^W				*/
#define BUTTON_FOLDER_X            56
#define BUTTON_FOLDER_Y             7
#define BUTTON_FOLDER_WIDTH        48
#define BUTTON_FOLDER_HEIGHT       48

/* Cɓ{^W				*/
#define BUTTON_FAVORITES_X        109
#define BUTTON_FAVORITES_Y          7
#define BUTTON_FAVORITES_WIDTH     48
#define BUTTON_FAVORITES_HEIGHT    48

/* {^W					*/
#define BUTTON_SEARCH_X           162
#define BUTTON_SEARCH_Y             7
#define BUTTON_SEARCH_WIDTH        48
#define BUTTON_SEARCH_HEIGHT       48

/* ݒ{^W					*/
#define BUTTON_SETTING_X          215
#define BUTTON_SETTING_Y            7
#define BUTTON_SETTING_WIDTH       48
#define BUTTON_SETTING_HEIGHT      48

/* ^C}[{^W				*/
#define BUTTON_TIMER_X            268
#define BUTTON_TIMER_Y              7
#define BUTTON_TIMER_WIDTH         48
#define BUTTON_TIMER_HEIGHT        48

/* TUNE{^W					*/
#define BUTTON_TUNE_X               3
#define BUTTON_TUNE_Y               7
#define BUTTON_TUNE_WIDTH          48
#define BUTTON_TUNE_HEIGHT         48

/* Cɓ֒ǉ{^W		*/
#define BUTTON_ADD_X               56
#define BUTTON_ADD_Y                7
#define BUTTON_ADD_WIDTH           48
#define BUTTON_ADD_HEIGHT          48

/* Cɓ肩폜{^W		*/
#define BUTTON_DELETE_X           109
#define BUTTON_DELETE_Y             7
#define BUTTON_DELETE_WIDTH        48
#define BUTTON_DELETE_HEIGHT       48

/* ߂{^W					*/
#define BUTTON_BACK_X             162
#define BUTTON_BACK_Y               7
#define BUTTON_BACK_WIDTH          48
#define BUTTON_BACK_HEIGHT         48

/* {^PW				*/
#define BUTTON_CLOSE1_X           215
#define BUTTON_CLOSE1_Y             7
#define BUTTON_CLOSE1_WIDTH        48
#define BUTTON_CLOSE1_HEIGHT       48

/* y[W_E{^W			*/
#define BUTTON_PAGE_DOWN_X        268
#define BUTTON_PAGE_DOWN_Y         59
#define BUTTON_PAGE_DOWN_WIDTH     48
#define BUTTON_PAGE_DOWN_HEIGHT    48

/* y[WAbv{^W			*/
#define BUTTON_PAGE_UP_X          268
#define BUTTON_PAGE_UP_Y          157
#define BUTTON_PAGE_UP_WIDTH       48
#define BUTTON_PAGE_UP_HEIGHT      48

/* Oȃ{^W					*/	
#define BUTTON_REV_X               45
#define BUTTON_REV_Y               75
#define BUTTON_REV_WIDTH           48
#define BUTTON_REV_HEIGHT          48

/* Đ^~{^W				*/	
#define BUTTON_PLAY_X             109
#define BUTTON_PLAY_Y              75
#define BUTTON_PLAY_WIDTH          48
#define BUTTON_PLAY_HEIGHT         48

/* ȃ{^						*/
#define BUTTON_FF_X               172
#define BUTTON_FF_Y                75
#define BUTTON_FF_WIDTH            48
#define BUTTON_FF_HEIGHT           48

/* s[g{^					*/
#define BUTTON_REPET_X            243
#define BUTTON_REPET_Y             75
#define BUTTON_REPET_WIDTH         48
#define BUTTON_REPET_HEIGHT        48

/* SHOUTCAST`FW{^			*/
#define BUTTON_CHG_SHOUTCAST_X      24
#define BUTTON_CHG_SHOUTCAST_Y      80
#define BUTTON_CHG_SHOUTCAST_WIDTH  48
#define BUTTON_CHG_SHOUTCAST_HEIGHT 48

/* PLAYER`FW{^				*/
#define BUTTON_CHG_PLAYER_X       136
#define BUTTON_CHG_PLAYER_Y        80
#define BUTTON_CHG_PLAYER_WIDTH    48
#define BUTTON_CHG_PLAYER_HEIGHT   48

/* FMWI`FW{^			*/
#define BUTTON_CHG_RADIO_X        248
#define BUTTON_CHG_RADIO_Y         80
#define BUTTON_CHG_RADIO_WIDTH     48
#define BUTTON_CHG_RADIO_HEIGHT    48

/* ֐vg^Cv錾				*/
void disp_main_menu_buttons( uint8_t bit );
void disp_list_menu_buttons( uint8_t bit );
void disp_speaker( void );
void disp_volume( uint8_t sw );
void disp_strbuffer( uint8_t sw );
void disp_init_sp( void );
void disp_shutdown_timer( void );
void disp_clock( void );
void disp_dspStatus( uint8_t sw );
void disp_shout_title( void );
void disp_music_title( void );
void disp_play_time( void );
void disp_play_buttons( void );
void disp_play_repet( uint8_t sw );
void disp_mode_change_buttons( void );

#endif
