/*###########################################################################
#                                                                           #
#                              \tgEGAL[{[h                       #
#                                                                           #
###########################################################################*/
#ifndef __SOFT_KEY_H__
#define __SOFT_KEY_H__

#include <avr/io.h>
#include "EGO028Q02.h"
#include "graphic.h"
#include "touch.h"

#ifndef ON
#define ON 1
#endif

#ifndef OFF
#define OFF 0
#endif

/* {^\				*/
typedef struct BUTTON_t {
	G_DRAWMODE mode;							/* `惂[h				*/
	uint8_t fontNum;							/* tHgԍ				*/
	uint8_t code;								/* ăR[h				*/
	RECT rect;									/* {^̈				*/
	uint16_t fcColor;							/* F					*/
	uint16_t bgColor;							/* wiF					*/
	char *txt;									/* \eLXgւ̃|C^	*/
} BUTTON;

/* {^Xg				*/
typedef struct BUTTON_LIST_t {
	uint16_t count;								/* o^{^				*/
	BUTTON keys[];								/* {^ACe			*/
} BUTTON_LIST;

/* ֐vg^Cv錾		*/
uint8_t inputBox( G_DRAWMODE gmode ,char *msg ,char *text );
uint8_t msgBox( G_DRAWMODE gmode ,uint8_t fontNum ,char *msg ,uint8_t flag );
BUTTON *button_get( BUTTON_LIST *btl ,POINT *pos );
void button_draw( BUTTON *btn ,uint8_t sw );

#endif
