/*############################################################################
#                                                                            #
#   		                  DHCPNCAg								 #
# Qlj                                                                     #
# http://www.wiznet.co.kr/UpLoad_Files/ReferenceFiles/W5100_Appnote_DHCP.zip #
#                                                                            #
############################################################################*/
#ifndef __DHCPC_H__
#define __DHCPC_H__

#include <avr/io.h>

/* DHCPNCAgXe[^X	*/
#define	DHCP_STS_DISABLE    0		/* DHCP(ŒIP[h)				*/
#define	DHCP_STS_DISCOVER	1		/* DHCPT[o[₢킹				*/
#define	DHCP_STS_REQUEST	2		/* DHCPT[o[v					*/
#define	DHCP_STS_LEASED		3		/* IP擾ςݏ						*/
#define	DHCP_STS_REREQUEST	4		/* DHCPT[o[ėv					*/

/* DHCP샂[h				*/
#define IP_STATIC  0				/* ŒIP[h							*/
#define IP_DYNAMIC 1				/* IPݒ胂[h						*/

/* DHCP NCg\	*/
typedef struct DHCP_INFO_t {
	uint8_t status;					/* DHCPNCAgXe[^X			*/
	uint8_t retry;					/* gCJE^						*/
	uint32_t xid;					/* DHCPbZ[WID						*/
	uint32_t dhcp_srever_ip;		/* ĂꂽDHCPT[o[IP			*/
	uint32_t getIP;					/* OFFERŎ擾IPAhX			*/
	uint32_t getSUBNET;				/* OFFERŎ擾Tulbg			*/
	uint32_t getGATEWAY;			/* OFFERŎ擾Q[gEGC			*/
	uint32_t getDNS;				/* OFFERŎ擾DNST[o[			*/
	uint32_t oldIP;					/* ԉp							*/
	volatile uint32_t ipTimer;		/* IPAhX[Xc莞			*/
	volatile uint16_t timeOut;		/* bZ[WM^CAEg^C}[	*/
} DHCP_INFO;

/* ֐vg^Cv錾			*/
void dhcpClient_timer( void );
uint8_t dhcpClient_init( void );
void dhcpClient_task( void );

#endif
