/*###########################################################################
#                                                                           #
#                           NTPNCAg                                 #
#                                                                           #
# Ql) http://wiki.livedoor.jp/yamamaya_com/                               #
#       http://wiki.livedoor.jp/yamamaya_com/d/NTP%bb%fe%b7%d7ver.1         #
#                                                                           #
#                                                                           #
###########################################################################*/
#ifndef __NTPC_H__
#define __NTPC_H__

#include <avr/io.h>

#define NTPC_NEXT_TIME ( 2UL * 360000LU )	/* ēԊu(2)			*/

/* \					*/
typedef struct TIME_t {
	uint16_t year;
	uint8_t  month;
	uint8_t  day;
	uint8_t	 wday;
	uint8_t	 hour;
	uint8_t  minute;
	uint8_t  second;
} TIME;

/* NTPCǗ\				*/
typedef struct NTPC_INFO_t {
	volatile uint32_t timeout;
	volatile uint32_t systemTime;
	uint32_t lastUpdate;
	uint8_t update;							/* XV 0:Ȃ 1:L		*/
	volatile uint8_t ms10Count;				/* 10msecJE^				*/
	volatile uint8_t tickSec;				/* VXebωtO		*/
} NTPC_INFO;

/* ֐vg^Cv錾			*/
void ntpc_timer( void );
void ntpc_init( void );
void ntpc_task( void );
uint32_t ntpc_getTime( TIME *t );
uint32_t ntpc_getLastUpdate( TIME *t );

#endif
