/*###########################################################################
#                                                                           #
#        	  				HTTP										#
#                                                                           #
###########################################################################*/
#define __HTTP_C__
#include "project.h"

/* [Jϐ錾				*/
static uint8_t updateNetPara = 0;
static uint8_t sendSts = 0;

/* [J֐vg^Cv錾	*/
static void html_index( char *pCmd );
static void html_search( char *pCmd );
static void html_tune( char *pCmd );
static void html_net( char *pCmd );
static void html_setmac( char *pCmd );
static void html_sethost( char *pCmd );
static void html_setntp( char *pCmd );
static void html_station( char *pCmd );

static uint8_t getCommandItem( char *pCmd ,const char *name ,uint16_t size ,char *buf );
static void sends_P( const prog_char *txt );
static void sends( char *txt );
static void sends_SS( SSMP txt );

/*****************************************************************************
*							HTTPR}h
* Fchar *cmd R}h
* ߒlFvoid
*****************************************************************************/
void http_process( char *cmd )
{
	/* X|X				*/
	static const prog_char res1[] = 
		"HTTP/1.0 200 OK\r\n"
		"Content-Type: text/html\r\n"
		"Connection: Close\r\n"
		"\r\n";

	/* HTML wb_			*/
	static prog_char HEAD[] =
		"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">"
		"<HTML><HEAD>"
		"<META http-equiv=\"Content-Type\" content=\"text/html; charset=Shift_JIS\">"
		"<META http-equiv=\"Content-Style-Type\" content=\"text/css\">"
		"<TITLE>nRADIO</TITLE>"
		"</HEAD><BODY bgcolor=\"#00ffff\">"
		"<CENTER><P><FONT size=\"+2\" face=\"Arial Black\">nRADIO</FONT>SHOUTCASTplbgWI&nbsp;&nbsp;by <A href=\"http://npyo.web.fc2.com/\" target=\"_blank\" style=\"text-decoration:none;\"><B>nPYO</B></A></P>"
		"<TABLE border=\"8\" bgcolor=\"#00ff00\"><TBODY>"
		"<TR align=middle>"
		"<TD width=\"170\" height=\"40\"><I><A href=\"index.html\" target=\"_self\" style=\"text-decoration:none;\">ĐXe[^X</A></I></TD>"
		"<TD width=\"170\" height=\"40\"><I><A href=\"station.html\" target=\"_self\" style=\"text-decoration:none;\">o^Xe[Vꗗ</A></I></TD>"
		"<TD width=\"170\" height=\"40\"><I><A href=\"search.html\" target=\"_self\" style=\"text-decoration:none;\">Xe[V</A></I></TD>"
		"<TD width=\"170\" height=\"40\"><I><A href=\"net.html\" target=\"_self\" style=\"text-decoration:none;\">lbg[Nݒ</A></I></TD>"
		"</TR></TBODY></TABLE><BR>";

	/* HTML tb^			*/
	static prog_char FOOTER[] = "</CENTER></BODY></HTML>";

	char *p1;
	uint16_t len;

	sendSts = 0;
	updateNetPara = 0;

	/* p[^`FbN			*/
	len = strlen( cmd );
	if ( !len ) {
		return;
	}

	p1 = strchr( cmd ,'?' );
	if ( p1 ) {
		*p1++ = '\0';
	} else {
		p1 = &cmd[ len - 1 ];
	} 

	/* bZ[WM	*/
	sends_P( res1 );

	/* HTMLwb_M		*/
	sends_P( HEAD );
	
	/* e						*/
	if ( eep.playMode == SYSTEM_MODE_SHOUTCAST ) {
		if ( !strcmp_P( cmd ,PSTR("/") ) || !strcasecmp_P( cmd ,PSTR("/index.html") ) ) {
			html_index( p1 );
		} else if ( !strcasecmp_P( cmd ,PSTR("/search.html") ) ) {
			html_search( p1 );
		} else if ( !strcasecmp_P( cmd ,PSTR("/tune.html") ) ) {
			html_tune( p1 );
		} else if ( !strcasecmp_P( cmd ,PSTR("/net.html") ) ) {
			html_net( p1 );
		} else if ( !strcasecmp_P( cmd ,PSTR("/station.html") ) ) {
			html_station( p1 );
		} else if ( !strcasecmp_P( cmd ,PSTR("/setmac.html") ) ) {
			html_setmac( p1 );
		} else if ( !strcasecmp_P( cmd ,PSTR("/sethost.html") ) ) {
			html_sethost( p1 );
		} else if ( !strcasecmp_P( cmd ,PSTR("/setntp.html") ) ) {
			html_setntp( p1 );
		}
	} else {
		sends_P( PSTR("<FONT size=\"+1\"><B>SHOUTCAST[hł͂܂B</B></FONT>") );
	}

	/* HTMLtb^[M		*/
	sends_P( FOOTER );

	/* lbg[Np[^ύX̏	*/
	if ( !sendSts && updateNetPara ) {			/* Mlbg[Np[^ύXLH	*/
		tcp_disconnect( HTTPS_SOCK );
		save_netInfo( &netInfo );				/* EEPۑ										*/
		mcu_soft_reset();						/* Zbg	*/
	}
}

/*****************************************************************************
*								index.html
* Fchar *pCmd  R}hւ̃|C^
* ߒlFvoid
*****************************************************************************/
static void html_index( char *pCmd )
{
	uint8_t index;
	uint8_t i;
	char buf[8];
	char url[URL_SIZE];
	char title[ SHOUTCAST_TITLE_SIZE + 3 ];
	char name[ SHOUTCAST_NAME_SIZE + 3 ];

	/* 								*/
	sends_P( PSTR("<FONT size=\"+1\"><B>ĐXe[^X</B></FONT><BR><TABLE border=\"4\" bgcolor=\"#c0c0ff\"><TBODY><TR><TD align=middle bgcolor=\"#ffff80\" width=\"200\" height=\"32\" ><B></B></TD><TD bgcolor=\"#c0c0ff\" width=\"500\">") );
	if ( shoutInfo->mode == SHOUTCAST_TIMEOUT ) {
		sends_P( PSTR("&nbsp;ڑ [") );
		sends_SS( ADDR_pUrl );
		sends_P( PSTR("]&nbsp;") );
	} else if ( shoutInfo->mode == SHOUTCAST_BUFFERING ) {
		sends_P( PSTR("&nbsp;obt@O&nbsp;") );
	} else if ( shoutInfo->mode == SHOUTCAST_PLAYING ) {
		sends_P( PSTR("&nbsp;Đ&nbsp;") );
	} else if ( shoutInfo->mode == SHOUTCAST_CONNECT ) {
		sends_P( PSTR("&nbsp;ڑ&nbsp;") );
	} else {
		sends_P( PSTR("&nbsp;~&nbsp;") );
	}

	sends_P( PSTR("</TD></TR>") );

	/* MXe[V			*/
	if ( ( shoutInfo->mode == SHOUTCAST_BUFFERING ) || ( shoutInfo->mode == SHOUTCAST_PLAYING ) ) {
		sends_P( PSTR("<TR><TD height=\"32\" align=middle bgcolor=\"#ffff80\"><B>Xe[V</B></TD><TD bgcolor=\"#c0c0ff\">&nbsp;") );

		memcpy_SS( name ,ADDR_pStationName ,SHOUTCAST_NAME_SIZE );
		memset( &name[SHOUTCAST_NAME_SIZE] ,0x00 ,3 );
		g_convSJIS( name ,sizeof(name) ,name ,PR_UTF8_UTF16_SJIS );
		sends( name );

		sends_P( PSTR("&nbsp;</TD></TR><TR><TD height=\"32\" align=middle bgcolor=\"#ffff80\"><B>z[y[W</B></TD><TD bgcolor=\"#c0c0ff\"><A style=\"text-decoration:none;\" href=\"") );
		sends_SS( ADDR_pStationURL );
		sends_P( PSTR("\" target=\"_blank\">&nbsp;") );
		sends_SS( ADDR_pStationURL );
		sends_P( PSTR("&nbsp;</A></TD></TR><TR><TD height=\"32\" align=middle bgcolor=\"#ffff80\"><B>Ȗ</B></TD><TD bgcolor=\"#c0c0ff\">&nbsp;") );

		memcpy_SS( title ,ADDR_pStreamTile ,SIZE_pStreamTile );
		memset( &title[SIZE_pStreamTile] ,0x00 ,3 );
		g_convSJIS( title ,sizeof(title) ,title ,PR_UTF8_UTF16_SJIS );
		sends( title );

		sends_P( PSTR("&nbsp;</TD></TR><TR><TD height=\"32\" align=middle bgcolor=\"#ffff80\"><B>f[^`</B></TD><TD bgcolor=\"#c0c0ff\">&nbsp;") );
		sends_SS( ADDR_pContentType );
		sprintf_P( buf ,PSTR("(%uKbps)") ,ss_read_word( ADDR_pBr ) );
		sends( buf );
		sends_P( PSTR("&nbsp;</TD></TR>") );
	}

	sends_P( PSTR("</TBODY></TABLE>") );

	/* o^Xgɋ󂫂Γo^N\	*/
	if ( shoutInfo->mode & 0x80 ) {
		strcpy_s_SS( url ,sizeof(url) ,ADDR_pUrl );
		if ( ( search_station( url ,&i ) != 0 ) && ( free_station( &index ) == 0 ) ) {
			sends_P( PSTR("<BR><BR><TABLE border=\"4\" bgcolor=\"#ff80ff\"><TBODY><TR align=\"center\"><TD height=\"32\"><A href=\"station.html?save=") );
			sprintf_P( buf ,PSTR("%u") ,index );
			sends( buf );
			sends_P( PSTR("\" target=\"_self\" style=\"text-decoration:none;\"><B>&nbsp;&nbsp;Xe[Vꗗɓo^&nbsp;&nbsp;</B></A></TD></TR></TBODY></TABLE>") );
		}
	}
}

/*****************************************************************************
*								search.html
* Fchar *pCmd  R}hւ̃|C^
* ߒlFvoid
*****************************************************************************/
static void html_search( char *pCmd )
{
	uint8_t itemCount;
	uint8_t ret;
	uint16_t n;
	uint8_t errorFlag;
	char key[26];
	char base[ 32 ];
	char buf[ SHOUTCAST_NAME_SIZE + 2 ];

	/* L[[h擾			*/
	ret = getCommandItem( pCmd ,PSTR("key") ,sizeof(key) ,key );

	/* tH[쐬				*/
	sends_P( PSTR("<FONT size=\"+1\"><B>Xe[V</B></FONT><FORM>L[[h(p)@<INPUT type=\"text\" maxlength=\"24\" style=\"WIDTH: 200px\" value=\"") );
	sends( key );
	sends_P( PSTR("\" name=\"key\"><BUTTON style=\"WIDTH: 60px\" type=\"submit\" name=\"search\"></BUTTON></FORM>") );

	/* Jn						*/
	errorFlag = 0;
	if ( ret == 0 ) {
		if ( key[0] == '\0' ) {
			strcpy_s_P( buf ,sizeof(buf) ,PSTR("L[[h͂Ă܂B") );
			errorFlag = 1;

		} else {
			ret = shoutcast_stationSearch( key ,ADDR_pListBuffer2 ,SIZE_pListBuffer2 );
			if ( ret != 0 ) {
				sprintf_P( buf ,PSTR("ɃG[ #%u ܂B") ,ret );
				errorFlag = 1;

			} else {
				itemCount = shoutcast_stationItemCount( ADDR_pListBuffer2 );
				if ( itemCount == 0 ) {
					strcpy_s_P( buf ,sizeof(buf) ,PSTR("L[[hɈvXe[V܂łB") );
					errorFlag = 1;

				} else {
					strcpy_s_P( base ,sizeof(base) ,SHOUTCAST_BASE );
					sends_P( PSTR("<table border=\"1\" bgColor=#c0c0ff><tbody><TR align=\"center\" bgColor=#ffff80><td width=\"80\"><b>ԍ</b></td><td width=\"600\"><b>Xe[V</b></td><td width=\"120\"><b>f[^`</b></td></tr>") );
					for ( n = 0 ;n < itemCount ;n++ ) {
						/* CfbNXԍ						*/
						sends_P( PSTR("<TR><td align=middle>") );
	
						sprintf_P( buf ,PSTR("%3d") ,n + 1 );
						sends( buf );

						/* Xe[V						*/
						sends_P( PSTR("</td><td><a href=\"http://") );
						sends( inet_ntoa( netInfo.ip ) );
						sends_P( PSTR("/tune.html?base=") );
						sends( base );
						sends_P( PSTR("&id=") );

						shoutcast_stationItem( ADDR_pListBuffer2 ,n ,SHOUTCAST_ITEM_ID ,buf ,sizeof(buf) );
						sends( buf );

						sends_P( PSTR("\">") );

						shoutcast_stationItem( ADDR_pListBuffer2 ,n ,SHOUTCAST_ITEM_NAME  ,buf ,sizeof(buf) );
						sends( buf );

						/* Xg[~O`rbg[g		*/
						sends_P( PSTR("</td><td align=middle>") );
						shoutcast_stationItem( ADDR_pListBuffer2 ,n ,SHOUTCAST_ITEM_MT ,buf ,sizeof(buf) );
						sends( buf );
						sends_P( PSTR(" ") );
						shoutcast_stationItem( ADDR_pListBuffer2 ,n ,SHOUTCAST_ITEM_BR ,buf ,sizeof(buf) );
						sends( buf );
						sends_P( PSTR("Kbps</td></tr>") );
					}

					sends_P( PSTR("</tbody></table>") );
				}
			}
		}
	}

	/* G[bZ[W쐬					*/
	if ( errorFlag != 0 ) {
		sends_P( PSTR("<BR><P><B><FONT color=\"#ff0000\">") );
		sends( buf );
		sends_P( PSTR("</FONT></B></P>") );
	}

	/* Xg[~O^CAEg	*/
	if ( ( shoutInfo->mode == SHOUTCAST_BUFFERING ) || ( shoutInfo->mode == SHOUTCAST_PLAYING ) ) {
		shoutInfo->recvTimeout = STREAMING_TIMEOUT;
	}
}

/*****************************************************************************
*								tune.html
* Fchar *pCmd  R}hւ̃|C^
* ߒlFvoid
*****************************************************************************/
static void html_tune( char *pCmd )
{
	uint8_t errorFlag = 0;
	uint8_t ret;
	char id[ SHOUTCAST_ID_SIZE + 2 ];
	char buf[256];

	/* p[^擾				*/
	getCommandItem( pCmd ,PSTR("id") ,sizeof(id) ,id );
	if ( !id[0] ) {
		strcpy_s_P( buf ,sizeof(buf) ,PSTR("p[^G[łB") );
		errorFlag = 1;
	}

	/* PLSt@C擾			*/
	ret = shoutcast_download_pls( id ,ADDR_pPlsBuffer ,SIZE_pPlsBuffer );
	if ( ret != 0 ) {
		sprintf_P( buf ,PSTR("PLSt@C擾ł܂łB #%u") ,ret );
		errorFlag = 1;

	} else {
		if ( shoutcast_pls_count( ADDR_pPlsBuffer ) == 0 ) {
			strcpy_s_P( buf ,sizeof(buf) ,PSTR("PLSt@CɃACe܂B") );
			errorFlag = 1;

		} else {
			shoutcast_pls_item( ADDR_pPlsBuffer ,0 ,sizeof(buf) ,buf );
			strcat_s_P( buf ,sizeof(buf) ,PSTR("<BR>ڑJn܂B") );
		}
	}

	if ( errorFlag == 0 ) {
		sends_P( PSTR("<BR><P><B><FONT color=\"#000000\">") );
	} else {
		sends_P( PSTR("<BR><P><B><FONT color=\"#ff0000\">") );
	}
	sends( buf );
	sends_P( PSTR("</FONT></B></P>") );

	/* Xg[~O							*/
	if ( errorFlag == 0 ) {
		shoutcast_pls_item( ADDR_pPlsBuffer ,0 ,sizeof(buf) ,buf );
		ss_strcpy_s( ADDR_pUrl ,SIZE_pUrl ,buf );
		shoutcast_start();

	} else {
		if ( ( shoutInfo->mode == SHOUTCAST_BUFFERING ) || ( shoutInfo->mode == SHOUTCAST_PLAYING ) ) {
			shoutInfo->recvTimeout = STREAMING_TIMEOUT;
		}
	}
}

/*****************************************************************************
*								net.html
* Fchar *pCmd  R}hւ̃|C^
* ߒlFvoid
*****************************************************************************/
static void html_net( char *pCmd )
{
	char buf[32];
	TIME t;

	/* MACAhX					*/
	sends_P( PSTR("<FONT size=\"+1\"><B>lbg[Np[^</B></FONT><BR><TABLE border=\"4\" bgcolor=\"#c0c0ff\"><TBODY><TR height=\"32\"><TD align=\"center\" bgcolor=\"#ffff80\" width=\"300\"><B>MACAhX</B></TD><TD width=\"300\">&nbsp;") );
	sprintf_P( buf ,PSTR("%02X-%02X-%02X-%02X-%02X-%02X") ,netInfo.mac[0] ,netInfo.mac[1] ,netInfo.mac[2] ,netInfo.mac[3] ,netInfo.mac[4] ,netInfo.mac[5] );
	sends( buf );

	/* zXg						*/
	sends_P( PSTR("</TD><TD><A href=\"setmac.html\" target=\"_self\" style=\"text-decoration:none;\">&nbsp;ύX&nbsp;</A></TD></TR><TR height=\"32\"><TD align=\"center\" bgcolor=\"#ffff80\"><B>zXg</B></TD><TD>&nbsp;") );
	sends( netInfo.hostname );

	/* IPAhX					*/
	sends_P( PSTR("</TD><TD><A href=\"sethost.html\" target=\"_self\" style=\"text-decoration:none;\">&nbsp;ύX&nbsp;</A></TD></TR><TR height=\"32\"><TD align=\"center\" bgcolor=\"#ffff80\"><B>IPAhX</B></TD><TD>&nbsp;") );
	sends( inet_ntoa( netInfo.ip ) );

	/* SUBNET						*/
	sends_P( PSTR("</TD><TD>&nbsp;</TD></TR><TR height=\"32\"><TD align=\"center\" bgcolor=\"#ffff80\"><B>Tulbg}XNAhX</B></TD><TD>&nbsp;") );
	sends( inet_ntoa( netInfo.subnet ) );

	/* GATEWAY						*/
	sends_P( PSTR("</TD><TD>&nbsp;</TD></TR><TR height=\"32\"><TD align=\"center\" bgcolor=\"#ffff80\"><B>ftHgQ[gEGCAhX</B></TD><TD>&nbsp;") );
	sends( inet_ntoa( netInfo.gateway ) );

	/* DNS							*/
	sends_P( PSTR("</TD><TD>&nbsp;</TD></TR><TR height=\"32\"><TD align=\"center\" bgcolor=\"#ffff80\"><B>DNST[o[IPAhX</B></TD><TD>&nbsp;") );
	sends( inet_ntoa( netInfo.dns ) );

	/* NTP URL						*/
	sends_P( PSTR("</TD><TD>&nbsp;</TD></TR><TR height=\"32\"><TD align=\"center\" bgcolor=\"#ffff80\"><B>NTPT[o[URL</B></TD><TD>&nbsp;") );
	sends( netInfo.ntpname );

	/* NTP IP						*/
	sends_P( PSTR("</TD><TD><A href=\"setntp.html\" target=\"_self\" style=\"text-decoration:none;\">&nbsp;ύX&nbsp;</A></TD></TR><TR height=\"32\"><TD align=\"center\" bgcolor=\"#ffff80\"><B>NTPT[o[IPAhX</B></TD><TD>&nbsp;") );
	sends( inet_ntoa( netInfo.ntp ) );

	/* NTP LAST UPDATE				*/
	sends_P( PSTR("</TD><TD>&nbsp;</TD></TR><TR height=\"32\"><TD align=\"center\" bgcolor=\"#ffff80\"><B>NTPŏI</B></TD><TD>&nbsp;") );
	ntpc_getLastUpdate( &t );
	sprintf_P( buf ,PSTR("%uN%u%u&nbsp;%u%u") ,t.year ,t.month ,t.day ,t.hour ,t.minute );
	sends( buf );

	/* DHCP STATUS					*/
	sends_P( PSTR("</TD><TD>&nbsp;</TD></TR><TR height=\"32\"><TD align=\"center\" bgcolor=\"#ffff80\"><B>DHCPXe[^X</B></TD><TD>&nbsp;") );

	if ( netInfo.dhcpMode == IP_STATIC ) {
		sends_P( PSTR("~") );
	} else if ( dhcpInfo.status == DHCP_STS_DISCOVER ) {
		sends_P( PSTR("DISCOVER") );
	} else if ( dhcpInfo.status == DHCP_STS_REQUEST ) {
		sends_P( PSTR("REQUEST") );
	} else if ( dhcpInfo.status == DHCP_STS_LEASED ) {
		sends_P( PSTR("LEASED") );
	} else if ( dhcpInfo.status == DHCP_STS_REREQUEST ) {
		sends_P( PSTR("REREQUEST") );
	} else {
		sends_P( PSTR("sȃXe[^X") );
	}

	if ( dhcpInfo.ipTimer ) {
		sprintf_P( buf ,PSTR("&nbsp;&nbsp;(&nbsp;[X&nbsp;%u%u%ub&nbsp;)&nbsp;") ,(uint16_t)( dhcpInfo.ipTimer / 3600L ) ,(uint16_t)( ( dhcpInfo.ipTimer % 3600L ) / 60L ) ,(uint16_t)( dhcpInfo.ipTimer % 60L ) );
		sends( buf );
	}

	sends_P( PSTR("</TD><TD>&nbsp;</TD></TR></TBODY></TABLE>") );
}

/*****************************************************************************
*								setmac.html
* Fchar *pCmd  R}hւ̃|C^
* ߒlFvoid
*****************************************************************************/
static void html_setmac( char *pCmd )
{
	uint8_t errorFlag = 0;
	uint8_t button = 0;
	char buf[64];
	uint8_t mac[6];
	uint8_t ret = 0;

	/* p[^擾				*/
	button = ( getCommandItem( pCmd ,PSTR("set") ,sizeof(buf) ,buf ) == 0 );
	if ( !button ) {
		memcpy( mac ,netInfo.mac ,6 );

	} else {
		ret = getCommandItem( pCmd ,PSTR("val") ,sizeof(buf) ,buf );
		if ( ret == 0 ) {
			errorFlag = mac_addr( buf ,mac );
		}
	}

	/* ʍ쐬					*/
	sends_P( PSTR("<FONT size=\"+1\"><B>MACAhXύX</B></FONT><BR><FORM>MACAhX@<INPUT type=\"text\" maxlength=\"17\" style=\"WIDTH: 200px\" value=\"") );

	sprintf_P( buf ,PSTR("%02X-%02X-%02X-%02X-%02X-%02X") ,mac[0] ,mac[1] ,mac[2] ,mac[3] ,mac[4] ,mac[5] );
	sends( buf );

	sends_P( PSTR("\" name=\"val\"><BUTTON style=\"WIDTH: 60px\" type=\"submit\" name=\"set\">m</BUTTON></FORM>MACAhX xx-xx-xx-xx-xx-xx `̕œ͂ĉB<BR>ȈՃVXëׁA΂ɑ̋@ƏdȂMACAhX͂ĉB") );

	/* MACAhXύX			*/
	if ( button ) {
		if ( ret != 0 ) {
			strcpy_s_P( buf ,sizeof(buf) ,PSTR("MACAhX̓͂܂B") );
			errorFlag = 1;

		} else {
			if ( errorFlag ) {
				strcpy_s_P( buf ,sizeof(buf) ,PSTR("MACAhX̏ԈĂ܂B") );
				errorFlag = 1;

			} else {
				if ( memcmp( netInfo.mac ,mac ,6 ) == 0 ) {
					strcpy_s_P( buf ,sizeof(buf) ,PSTR("݂MACAhXƓAhX͂Ă܂B") );
					errorFlag = 1;

				} else {
					strcpy_s_P( buf ,sizeof(buf) ,PSTR("MACAhXύX܂B<BR>ċN܂B") );
					memcpy( netInfo.mac ,mac ,6 );
					updateNetPara = 1;
					errorFlag = 0;
				}
			}
		}

		sends_P( PSTR("<BR><P><B><FONT color=\"#") );
		if ( errorFlag ) {
			sends_P( PSTR("ff0000") );
		} else {
			sends_P( PSTR("000000") );
		}
		sends_P( PSTR("\">") );
		sends( buf );
		sends_P( PSTR("</FONT></B></P>") );
	}
}

/*****************************************************************************
*								sethost.html
* Fchar *pCmd  R}hւ̃|C^
* ߒlFvoid
*****************************************************************************/
static void html_sethost( char *pCmd )
{
	char c ,*p;
	uint8_t button;
	char hostname[16];
	char buf[64];
	uint8_t errorFlag = 0;

	/* p[^擾				*/
	button = ( getCommandItem( pCmd ,PSTR("set") ,sizeof(buf) ,buf ) == 0 );
	if ( !button ) {
		strcpy_s( hostname ,sizeof(hostname) ,netInfo.hostname );

	} else {
		getCommandItem( pCmd ,PSTR("val") ,sizeof(buf) ,buf );
		if ( strlen( buf ) <= 15 ) {
			strcpy_s( hostname ,sizeof(hostname) ,buf );
		}
	}

	/* ʍ쐬					*/
	sends_P( PSTR("<FONT size=\"+1\"><B>zXgύX</B></FONT><BR><FORM>zXg@<INPUT type=\"text\" maxlength=\"15\" style=\"WIDTH: 200px\" value=\"") );
	sends( hostname );
	sends_P( PSTR("\" name=\"val\"><BUTTON style=\"WIDTH: 60px\" type=\"submit\" name=\"set\">m</BUTTON></FORM>zXgɎgp\\ȕ͉p('A'-'Z' 'a'-'z' '0'-'9')ƈꕔ̋L( @ # $ % ^ & ( ) = ' { } . ~ ) łB<BR>ȈՃVXëׁA΂ɑ̋@ƏdȂzXgw肵ĉB") );

	/* zXgύX				*/
	buf[0] = '\0';
	if ( button ) {

		/* gps`FbN	*/
		p = hostname;
		while ( *p ) {
			c = toupper( *p );
			if ( ( ( c < '0' ) || ( c > '9' ) ) && ( ( c < 'A' ) || ( c > 'Z' ) ) && ( strchr_P( PSTR("@#$%^&()='{}.~") ,c ) == NULL ) ) {
				break;
			}
			p++;
		}

		if ( hostname[0] == '\0' ) {
			strcpy_s_P( buf ,sizeof(buf) ,PSTR("zXg̓͂܂B") );
			errorFlag = 1;

		} else {
			if ( *p == '\0' ) {
				if ( strcmp( hostname ,netInfo.hostname ) != 0 ) {
					strcpy_s( netInfo.hostname ,sizeof(netInfo.hostname) ,hostname );
					strcpy_s_P( buf ,sizeof(buf) ,PSTR("zXgύX܂B<BR>ċN܂B") );
					updateNetPara = 1;

				} else {
					strcpy_s_P( buf ,sizeof(buf) ,PSTR("݂̃zXgƓ̕񂪓͂Ă܂B") );
					errorFlag = 1;
				}
			} else {
				strcpy_s_P( buf ,sizeof(buf) ,PSTR("gpłȂ܂܂Ă܂B") );
				errorFlag = 1;
			}
		}

		sends_P( PSTR("<BR><P><B><FONT color=\"#") );
		if ( errorFlag ) {
			sends_P( PSTR("ff0000") );
		} else {
			sends_P( PSTR("000000") );
		}
		sends_P( PSTR("\">") );
		sends( buf );
		sends_P( PSTR("</FONT></B></P>") );
	}
}

/*****************************************************************************
*								setntp.html
* Fchar *pCmd  R}hւ̃|C^
* ߒlFvoid
*****************************************************************************/
static void html_setntp( char *pCmd )
{
	uint8_t button;
	char domain[ sizeof(netInfo.ntpname) ];
	char buf[64];
	uint8_t errorFlag = 0;

	button = ( getCommandItem( pCmd ,PSTR("set") ,sizeof(buf) ,buf ) == 0 );
	if ( !button ) {
		strcpy_s( domain ,sizeof(domain) ,netInfo.ntpname );
	} else {
		getCommandItem( pCmd ,PSTR("val") ,sizeof(domain) ,domain );
	}

	/* ʍ쐬					*/
	sends_P( PSTR("<FONT size=\"+1\"><B>NTPT[o[ύX</B></FONT><BR><FORM>NTPT[o[@<INPUT type=\"text\" maxlength=\"63\" style=\"WIDTH: 200px\" value=\"") );
	sends( domain );
	sends_P( PSTR("\" name=\"val\"><BUTTON style=\"WIDTH: 60px\" type=\"submit\" name=\"set\">m</BUTTON></FORM>") );

	/* NTPAhXύX			*/
	if ( button ) {
		if ( domain[0] == '\0' ) {
			strcpy_s_P( buf ,sizeof(buf) ,PSTR("NTPT[o[̓͂܂B") );
			errorFlag = 1;

		} else {
			if ( isDomain( domain ) ) {
				if ( strcmp( domain ,netInfo.ntpname ) != 0 ) {
					strcpy_s( netInfo.ntpname ,sizeof(netInfo.ntpname) ,domain );
					strcpy_s_P( buf ,sizeof(buf) ,PSTR("NTPT[o[ύX܂B<BR>ċN܂B") );
					updateNetPara = 1;

				} else {
					strcpy_s_P( buf ,sizeof(buf) ,PSTR("݂NTPT[o[Ɠ̕񂪓͂Ă܂B") );
					errorFlag = 1;
				}
			} else {
				strcpy_s_P( buf ,sizeof(buf) ,PSTR("gpłȂ܂܂Ă܂B") );
				errorFlag = 1;
			}
		}

		sends_P( PSTR("<BR><P><B><FONT color=\"#") );
		if ( errorFlag ) {
			sends_P( PSTR("ff0000") );
		} else {
			sends_P( PSTR("000000") );
		}
		sends_P( PSTR("\">") );
		sends( buf );
		sends_P( PSTR("</FONT></B></P>") );
	}
}

/*****************************************************************************
*								station.html
* Fchar *pCmd  R}hւ̃|C^
* ߒlFvoid
*****************************************************************************/
static void html_station( char *pCmd )
{
	uint8_t ret;
	char buf[128];
	char name[ SHOUTCAST_NAME_SIZE ];
	char url[ URL_SIZE ];
	char doFlag = 0;
	uint16_t index = 0xffff;
	uint16_t br;

	prog_char *msg1 = PSTR("<P>p[^܂B</P>");
	prog_char *msg2 = PSTR("<P>p[^ɊԈႢ܂B</P>");
	prog_char *msg3 = PSTR("<P>R}hsł܂łB</P>");

	/* ݍĐURLo^		*/
	if ( getCommandItem( pCmd ,PSTR("save") ,sizeof(buf) ,buf ) == 0 ) {
		if ( buf[0] == '\0' ) {
			sends_P( msg1 );
			return;
		}

		if ( ( atou16( buf ,&index ) != 0 ) || ( index >= EEP_STATION_ITEM_MAX ) ) {
			sends_P( msg2 );
			return;
		}

		strcpy_s_SS( url ,sizeof(url) ,ADDR_pUrl );
		strcpy_s_SS( name ,sizeof(url) ,ADDR_pStationName );
		br = ss_read_word( ADDR_pBr );
		ret = save_station( index ,url ,name ,br );
		if ( ret != 0 ) {
			sends_P( msg3 );
			return;
		}

		doFlag = 1;

	/* Xe[VI				*/
	} else if ( getCommandItem( pCmd ,PSTR("tune") ,sizeof(buf) ,buf ) == 0 ) {
		if ( buf[0] == '\0' ) {
			sends_P( msg1 );
			return;
		}

		if ( ( atou16( buf ,&index ) != 0 ) || ( index >= EEP_STATION_ITEM_MAX ) ) {
			sends_P( msg2 );
			return;
		}

		ret = load_station( index ,sizeof(url) ,url ,sizeof(name) ,name ,&br );
		if ( ret != 0 ) {
			sends_P( msg3 );
			return;
		}

		ss_strcpy_s( ADDR_pUrl ,SIZE_pUrl ,url );
		shoutcast_start();

		doFlag = 2;

	/* Xe[V폜				*/
	} else if ( getCommandItem( pCmd ,PSTR("delete") ,sizeof(buf) ,buf ) == 0 ) {
		if ( buf[0] == '\0' ) {
			sends_P( msg1 );
			return;
		}

		if ( ( atou16( buf ,&index ) != 0 ) || ( index >= EEP_STATION_ITEM_MAX ) ) {
			sends_P( msg2 );
			return;
		}

		delete_station( index );
		doFlag = 3;
	}

	/* wb_			*/
	sends_P( PSTR("<FONT size=\"+1\"><B>o^Xe[Vꗗ</B></FONT><BR><table border=\"4\" bgColor=#c0c0ff><TBODY><TR align=\"center\" bgColor=#ffff80 height=\"32\"><TD width=\"50\"><B>ԍ</B></TD><TD width=\"600\"><B>Xe[V</B></TD><TD width=\"100\"><B>rbg[g</B></TD><TD width=\"50\">&nbsp;</TD></TR>") );

	/* ꗗ				*/
	for ( uint8_t i = 0 ; i < EEP_STATION_ITEM_MAX ;i++ ) {

		load_station( i ,sizeof(url) ,url ,sizeof(name) ,name ,&br );

		/* ԍ				*/
		sends_P( PSTR("<TR bgcolor=\"#c0c0ff\" height=\"32\"><TD align=\"center\">") );
		sprintf_P( buf ,PSTR("%u") ,i + 1 );
		sends( buf );

		/* Xe[V	*/
		if ( url[0] ) {
			sends_P( PSTR("</TD><TD>&nbsp;<A href=\"station.html?tune=") );
			sprintf_P( buf ,PSTR("%u") ,i );
			sends( buf );
			sends_P( PSTR("\" target=\"_self\" style=\"text-decoration:none;\">") );
			sends( name );

			sprintf_P( buf ,PSTR("</A></TD><TD align=\"center\">%3dKbps</TD>") ,br );
			sends( buf );

			sends_P( PSTR("<TD align=\"center\">") );
			sends_P( PSTR("<A href=\"station.html?delete=") );
			sprintf_P( buf ,PSTR("%u") ,i );
			sends( buf );
			sends_P( PSTR("\" target=\"_self\" style=\"text-decoration:none;\">폜</A>") );

		} else {
			sends_P( PSTR("</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;") );
		}

		sends_P( PSTR("</TD></TR>") );
	}

	sends_P( PSTR("</TBODY></TABLE>") );

	/* tb^[bZ[W				*/
	if ( doFlag ) {
		load_station( index ,sizeof(url) ,url ,sizeof(name) ,name ,&br );
		sends_P( PSTR("<BR>") );

		if ( doFlag == 1 ) {
			sends( name );
			sends_P( PSTR("<BR><B><FONT color=\"#0000ff\">") );
			sprintf_P( buf ,PSTR("%uԂɃXe[Vo^܂B") ,index + 1 );
			sends( buf );

		} else if ( doFlag == 2 ) {
		sends( name );
			sends_P( PSTR("<BR><B><FONT color=\"#0000ff\">") );
			sprintf_P( buf ,PSTR("%uԂ̃Xe[VɐڑJn܂B") ,index + 1 );
			sends( buf );

		} else if ( doFlag == 3 ) {
			sends_P( PSTR("<B><FONT color=\"#ff8000\">") );
			sprintf_P( buf ,PSTR("%uԂ̃Xe[V폜܂B") ,index + 1 );
			sends( buf );
		}

		sends_P( PSTR("</FONT></B>") );
	}
}

/*****************************************************************************
*					R}hp[^wACe擾
* Fchar       *pCmd R}h
*       const char *name ACe
*		uint16_t   size  obt@TCY
*		char       *buf  obt@
* ߒlFuint8_t          0:OK !0:wACe
*****************************************************************************/
static uint8_t getCommandItem( char *pCmd ,const char *name ,uint16_t size ,char *buf )
{
	uint16_t len;
	char *p1 ,*p2;

	buf[0] = '\0';

	/* ACe		*/
	p1 = strcasestr_P( pCmd ,name );
	if ( p1 == NULL ) {
		return ( 1 );
	}

	/* = 				*/
	p1 = strchr( p1 + strlen_P( name ) ,'=' );
	if ( p1 == NULL ) {
		return ( 2 );
	}
	p1++;

	/* ACe񒷎擾	*/
	p2 = strchr( p1 ,'&' );
	if ( p2 ) {
		len = ( (uint16_t)p2 - (uint16_t)p1 );
	} else {
		len = strlen( p1 );
	}

	/* ACe擾			*/
	if ( len > size ) {
		len = size - 1;
	}

	if ( len ) {
		memcpy( buf ,p1 ,len );
		buf[len] = '\0';
		strtrim( buf );
	}

	return ( 0 );
}

/*****************************************************************************
*						\Pbg֕PʂőM
* Fconst prog_char *txt
* ߒlFvoid
* Z𑗐MƃX傫Ȃ̂Œ
*****************************************************************************/
static void sends_P( const prog_char *txt )
{
	if ( !sendSts ) {
		uint16_t len = strlen_P( txt );
		sendSts |= tcp_send_P( HTTPS_SOCK ,txt ,len );
	}
}

static void sends( char *txt )
{
	if ( !sendSts ) {
		uint16_t len = strlen( txt );
		sendSts |= tcp_send( HTTPS_SOCK ,txt ,len );
	}
}

static void sends_SS( SSMP txt )
{
	if ( !sendSts ) {
		uint16_t len = strlen_SS( txt );
		sendSts |= tcp_send_SS( HTTPS_SOCK ,txt ,len );
	}
}

