/*############################################################################
#                                                                            #
#   		           SHOUTCASTWIC							 #
#                                                                            #
############################################################################*/
#define __MENU001_C__
#include "project.h"
#include "myutil/timer.h"

/* [J֐vg^Cv錾	*/
static void disp_init( void );

/*****************************************************************************
*						SHOUTCAST C
* Fvoid
* ߒlFvoid
*****************************************************************************/
void menu001( void )
{
	SHOUTCAST shoutBuffer;

	/* SHOUTCAST					*/
	shoutcast_init( &shoutBuffer );

	/* ʍ쐬						*/
	disp_init();

	/* C[v						*/
	while( 1 ) {

		/* VXe^XN				*/
		system_task();

		/* ^XVύX̃^Cg\	*/
		if ( shoutInfo->recvMetaData ) {
			shoutInfo->recvMetaData = 0;
			disp_shout_title();
		}

		/* XyAif[^M			*/
		if ( sys.sp_enable ) {
			g_setSpectrumData( (uint16_t *)sys.dsp_sp );
			sys.sp_enable = 0;
		}

		if ( ntpcInfo.tickSec ) {
			ntpcInfo.tickSec = 0;

			/* DSPXe[^X\			*/
			disp_dspStatus( 1 );

			/* Xg[obt@ԕ\	*/
			disp_strbuffer( 1 );

			/* Vbg_E^C}[\	*/
			disp_shutdown_timer();

			/* v\					*/
			disp_clock();
		}

		/* ^b`L[擾				*/
		uint8_t key = g_inkey();
		if ( key == 0 ) {
			continue;
		}

		if ( main_button_process( key ) ) {					/* ʃC		*/
			;

		} else if ( key == BUTTON_FAVORITES ) {				/* uCɓv		*/
			menu011();
			disp_init();

		} else if ( key == BUTTON_SEARCH ) {				/* uv				*/
			menu012();
			disp_init();

		} else if ( key == BUTTON_FOLDER ) {				/* utH_v			*/
			uint8_t backup_mode = eep.playMode;
			menu100();
			if ( eep.playMode != backup_mode ) {
				break;
			}
			disp_init();

		} else if ( key == BUTTON_MODE ) {					/* u[h؂ւv	*/
			uint8_t backup_mode = eep.playMode;
			menu101();
			if ( eep.playMode != backup_mode ) {
				break;
			}
			disp_init();

		} else if ( key == BUTTON_SETTING ) {				/* uݒv				*/
			menu102();
			disp_init();

		} else {
			continue;
		}

		g_clearInkey();
	}

	shoutInfo = NULL;
}

/*****************************************************************************
*							ʏ\
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void disp_init( void )
{
	g_off();
	g_clearButton();								/* o^{^NA			*/
	g_setSpectrumEnable( 0 );						/* XyAi\XV֎~		*/
	g_textScrollEnable( 0 );						/* ebv\XV֎~		*/
	g_cls();										/* ʃNA				*/
	disp_init_sp();									/* XyAi\		*/
	disp_shout_title();								/* ^Cgebv\		*/
	disp_strbuffer( 0 );							/* Xg[obt@\	*/
	disp_dspStatus( 0 );							/* DSPXe[^X\		*/
	disp_volume( 0 );								/* ʕ\					*/
	disp_main_menu_buttons( 0xff );					/* j[{^o^		*/
	g_buttonAllDraw();								/* o^{^\			*/
	disp_shutdown_timer();							/* Vbg_E^C}[	*/
	g_image( 1 ,GMODE ,RGB(0,0,0) ,15 ,67 ,262 ,124 );	/* S\				*/
	disp_clock();
	g_setSpectrumEnable( 1 );						/* XyAi\XV		*/
	g_on();											/* ʕ\					*/
	g_clearInkey();
}

