/*############################################################################
#                                                                            #
#   		           SHOUTCASTWIuCɓv					 #
#                                                                            #
############################################################################*/
#define __MENU011_C__
#include "project.h"
#include "myutil/timer.h"

#define PAGE_ITEM_MAX 5
#define PAGE_MAX ( ( EEP_STATION_ITEM_MAX + PAGE_ITEM_MAX - 1 ) / PAGE_ITEM_MAX )

/* ACe{^_W^TCY	*/
#define ITEM_BUTTON_X	     4
#define ITEM_BUTTON_Y		67
#define ITEM_BUTTON_WIDTH  264
#define ITEM_BUTTON_HEIGHT 	25
#define ITEM_BUTTON_STEP     1

#define BUTTON_ITEM0       200

/* [J֐vg^Cv錾	*/
static uint8_t disp_init( uint8_t i );
static void disp_page( uint8_t index );
static void disp_item( uint8_t index ,uint8_t sw );
static void tune( uint8_t index );
static void itemDelete( uint8_t index );

/*****************************************************************************
*						SHOUTCASTWIuCɓv
* Fvoid
* ߒlFvoid
*****************************************************************************/
void menu011( void )
{
	uint8_t index = 0xff;
	uint8_t page = 0;

	/* ʏ						*/
	index = disp_init( 0xff );
	page = index / PAGE_ITEM_MAX;

	/* C[v						*/
	sys.noProcessTimer = NOT_PROCESS_TIMEOUT;
	while ( sys.noProcessTimer ) {

		/* VXe^XN				*/
		system_task();

		/* ^XVύX̃^Cg\	*/
		if ( shoutInfo->recvMetaData ) {
			shoutInfo->recvMetaData = 0;
			disp_shout_title();
		}

		/* ^b`L[擾				*/
		uint8_t key = g_inkey();
		if ( key == 0 ) {
			continue;
		}

		if ( key == BUTTON_CLOSE ) {						/* uv			*/
			break;

		} else if ( key == BUTTON_PAGE_UP ) {				/* uy[Wv			*/
			if ( ++page >= PAGE_MAX ) page = 0;
			index = page * PAGE_ITEM_MAX;
			disp_page( page * PAGE_ITEM_MAX );

		} else if ( key == BUTTON_PAGE_DOWN ) {				/* uOy[Wv			*/
			if ( --page >= PAGE_MAX ) page = PAGE_MAX - 1;
			index = page * PAGE_ITEM_MAX;
			disp_page( page * PAGE_ITEM_MAX );

		} else if ( key == BUTTON_TUNE ) {					/* uTUNEv				*/
			tune( index );
			disp_init( index );

		} else if ( key == BUTTON_DELETE ) {				/* uDELETEv			*/
			itemDelete( index );
			disp_init( index );

		} else if ( ( key >= BUTTON_ITEM0 ) && ( key <= ( BUTTON_ITEM0 + PAGE_ITEM_MAX - 1 ) ) ) {	/* ACe	*/
			uint8_t i = ( page * PAGE_ITEM_MAX ) + ( key - BUTTON_ITEM0 );
			if ( index != i ) {								/* J[\\			*/
				disp_item( index ,0 );
				index = i;
				disp_item( index ,1 );
			}

		} else {
			continue;
		}

		sys.noProcessTimer = NOT_PROCESS_TIMEOUT;
		g_clearInkey();
	}
}

/*****************************************************************************
*							ʏ\
* Fuint8_t  i ICfbNXԍi0xff:)
* ߒlFuint8_t    IACeCfbNX
*****************************************************************************/
static uint8_t disp_init( uint8_t i )
{
	char url[URL_SIZE];
	uint8_t index;

	g_off();
	g_clearButton();										/* o^{^NA				*/
	g_setSpectrumEnable( 0 );								/* XyAi\XV֎~			*/
	g_textScrollEnable( 0 );								/* ebv\XV֎~			*/
	g_cls();												/* ʃNA					*/
	disp_list_menu_buttons( 0x75 );							/* e{^o^					*/

	shoutInfo->recvMetaData = 0;							/* ^\					*/
	disp_shout_title();

	g_buttonAllDraw();										/* o^{^\				*/

	/* ACe{^ijo^	*/
	uint16_t x = ITEM_BUTTON_X;
	uint16_t y = ITEM_BUTTON_Y;
	char buf[1];
	buf[0] = '\0';
	for ( uint8_t i = 0 ;i < PAGE_ITEM_MAX ;i++ ) {
		g_addButton( BUTTON_ITEM0 + i ,G_OPAQUE ,0 ,x ,y ,x + ITEM_BUTTON_WIDTH - 1 ,y + ITEM_BUTTON_HEIGHT - 1 ,buf ,0 ,0 );
		y += ( ITEM_BUTTON_HEIGHT + ITEM_BUTTON_STEP );
	}

	/* ĐURLEEP猟		*/
	if ( i == 0xff ) {
		PLAY_ISR_DISABLE();
		strcpy_s_SS( url ,sizeof(url) ,ADDR_pUrl );
		PLAY_ISR_ENABLE();
		if ( search_station( url ,&index ) != 0 ) index = 0;
	} else {
		index = i;
	}

	/* ŏ̃y[W\			*/
	disp_page( index );

	/* ʕ\						*/
	g_on();
	g_clearInkey();

	return ( index );
}

/*****************************************************************************
*							wCfbNX܂ރy[W\
* Fuint8_t index     \CfbNX
* ߒlFvoid
*****************************************************************************/
static void disp_page( uint8_t index )
{
	uint8_t page;
	uint8_t j;
	char buf[8];

	if ( index == 0xff ) {
		page = 0;
		j = 0;
	} else {
		page = index / PAGE_ITEM_MAX;
		j = page * PAGE_ITEM_MAX;
	}

	/* 1y[W̃ACe\	*/
	for ( uint8_t i = 0 ;i < PAGE_ITEM_MAX ;i++ ,j++ ) {
		disp_item( j ,index == j );
	}

	/* y[Wԍ\			*/
	g_puts_P( GMODE ,2 ,276 ,22 ,PSTR("page") ,RGB(255,255,255) ,RGB(0,0,0) );
	sprintf_P( buf ,PSTR("%2d/%2d") ,page + 1 ,PAGE_MAX );
	g_puts( GMODE ,2 ,276 ,39 ,buf ,RGB(255,128,0) ,RGB(0,0,0) );
}

/*****************************************************************************
*						wCfbNX̃ACe\
* Fuint8_t index \CfbNX
*		uint8_t sw    0:I 1:I
* ߒlFvoid
*****************************************************************************/
static void disp_item( uint8_t index ,uint8_t sw )
{
	char url[1] ,name[27];
	char buf[8];
	uint16_t fColor ,bColor;
	uint16_t n;

	if ( index == 0xff ) return;

	uint16_t x = ITEM_BUTTON_X;
	uint16_t y = ITEM_BUTTON_Y + ( index % PAGE_ITEM_MAX ) * ( ITEM_BUTTON_HEIGHT + ITEM_BUTTON_STEP );

	if ( load_station( index ,sizeof(url) ,url ,sizeof(name) ,name ,&n ) != 0 ) {
		name[0] = '\0';
	}

	if ( sw ) {
		fColor = RGB( 255 ,255 ,255 );
		bColor = RGB(   0 ,180 ,  0 );
	} else {
		fColor = RGB( 255 ,255 ,128 );
		bColor = RGB(   0 , 64 ,  0 );
	}

	g_boxF( G_OPAQUE ,x ,y ,x + ITEM_BUTTON_WIDTH - 1 ,y + ITEM_BUTTON_HEIGHT  - 1 ,bColor );

	sprintf_P( buf ,PSTR("%2d.") ,index + 1 );
	g_puts( G_OPAQUE ,2 ,x + 2 ,y + 4 ,buf ,fColor ,bColor );

	if ( name[0] ) {
		g_puts( G_OPAQUE ,2 ,x + 26 ,y + 4 ,name ,fColor ,bColor );

		sprintf_P( buf ,PSTR("%3uk") ,n );
		g_puts( G_OPAQUE ,1 ,x + ITEM_BUTTON_WIDTH - 25 ,y + 9 ,buf ,RGB(255,128,0) ,bColor );

	}
}

/*****************************************************************************
*					wCfbNX̃ACeI
* Fuint8_t index     CfbNX
* ߒlFvoid
*****************************************************************************/
static void tune( uint8_t index )
{
	char url[URL_SIZE] ,name[1];
	uint8_t ret = 0;
	uint16_t br;

	ret = load_station( index ,sizeof(url) ,url ,sizeof(name) ,name ,&br );
	if ( ret || ( url[0] == '\0' ) ) {
		g_msgBox_P( G_OPAQUE ,2 ,PSTR("ACeo^ł") ,1 );
	} else {
		PLAY_ISR_DISABLE();
		player_sound( SOUND_TOP_OF_MUSIC );
		g_msgBox_P( G_OPAQUE ,2 ,PSTR("  ") ,0 );
		ss_strcpy_s( ADDR_pUrl ,SIZE_pUrl ,url );
		shoutcast_start();
	}
}

/*****************************************************************************
*					wCfbNX̃ACe폜(EEP)
* Fuint8_t index 폜CfbNX
* ߒlFvoid
*****************************************************************************/
static void itemDelete( uint8_t index )
{
	char name[1] ,url[1];
	uint16_t br;
	
	if ( load_station( index ,sizeof(url) ,url ,sizeof(name) ,name ,&br ) != 0 ) {
		g_msgBox_P( G_OPAQUE ,2 ,PSTR("ACeo^ł") ,1 );
	} else {
		if ( g_msgBox_P( G_OPAQUE ,2 ,PSTR("ACe폜܂") ,3 ) == 1 ) {
			g_msgBox_P( G_OPAQUE ,2 ,PSTR("  ") ,0 );
			delete_station( index );
		}
	}
}
