/*############################################################################
#                                                                            #
#   		           SHOUTCASTWIuv							 #
#                                                                            #
############################################################################*/
#define __MENU012_C__
#include "project.h"
#include "myutil/timer.h"

#define PAGE_ITEM_MAX 5

/* ACe{^_W^TCY	*/
#define ITEM_BUTTON_X	     4
#define ITEM_BUTTON_Y		67
#define ITEM_BUTTON_WIDTH  264
#define ITEM_BUTTON_HEIGHT 	25
#define ITEM_BUTTON_STEP     1

#define BUTTON_ITEM0       200

/* [J֐vg^Cv錾	*/
static uint8_t search( void );
static void disp_init( uint8_t i ,uint8_t pageMax );
static void disp_page( uint8_t index ,uint8_t pageMax );
static void disp_item( uint8_t index ,uint8_t sw );
static void tune( uint8_t index );
static void itemAdd( uint8_t index );

/*****************************************************************************
*						SHOUTCASTWIuv
* Fvoid
* ߒlFvoid
*****************************************************************************/
void menu012( void )
{
	g_clearButton();								/* o^{^NA		*/
	g_setSpectrumEnable( 0 );						/* XyAi\XV֎~	*/
	g_textScrollEnable( 0 );						/* ebv\XV֎~	*/

	if ( netInfo.netInit != 0xff ) {
		g_msgBox_P( G_OPAQUE ,1 ,PSTR("lbg[N̏IĂ܂") ,1 );
		return;
	}

	/* L[[h					*/
	uint8_t itemCount = search();
	if ( itemCount == 0 ) {
		return;
	}

	/* y[WǗϐ				*/
	uint8_t pageMax = ( itemCount + PAGE_ITEM_MAX - 1 ) / PAGE_ITEM_MAX;
	uint8_t page = 0;
	uint8_t index = 0;

	/* ʍ쐬						*/
	disp_init( index ,pageMax );

	/* C[v						*/
	sys.noProcessTimer = NOT_PROCESS_TIMEOUT;
	while ( sys.noProcessTimer ) {

		/* VXe^XN				*/
		system_task();

		/* ^XVύX̃^Cg\	*/
		if ( shoutInfo->recvMetaData ) {
			shoutInfo->recvMetaData = 0;
			disp_shout_title();
		}

		/* ^b`L[擾				*/
		uint8_t key = g_inkey();
		if ( key == 0 ) {
			continue;
		}

		if ( key == BUTTON_CLOSE ) {						/* uv			*/
			break;

		} else if ( key == BUTTON_PAGE_UP ) {				/* uy[Wv			*/
			if ( pageMax > 1 ) {
				if ( ++page >= pageMax ) page = 0;
				index = page * PAGE_ITEM_MAX;
				disp_page( page * PAGE_ITEM_MAX ,pageMax );
			}

		} else if ( key == BUTTON_PAGE_DOWN ) {				/* uOy[Wv			*/
			if ( pageMax > 1 ) {
				if ( --page >= pageMax ) page = pageMax - 1;
				index = page * PAGE_ITEM_MAX;
				disp_page( page * PAGE_ITEM_MAX ,pageMax );
			}

		} else if ( key == BUTTON_TUNE ) {					/* uTUNEv				*/
			tune( index );
			disp_init( index ,pageMax );

		} else if ( key == BUTTON_ADD ) {					/* uADDv				*/
			itemAdd( index );
			disp_init( index ,pageMax );

		} else if ( ( key >= BUTTON_ITEM0 ) && ( key <= ( BUTTON_ITEM0 + PAGE_ITEM_MAX - 1 ) ) ) {	/* ACe	*/
			uint8_t i = ( page * PAGE_ITEM_MAX ) + ( key - BUTTON_ITEM0 );
			if ( index != i ) {								/* J[\\			*/
				disp_item( index ,0 );
				index = i;
				disp_item( index ,1 );
			}

		} else {
			continue;
		}

		sys.noProcessTimer = NOT_PROCESS_TIMEOUT;
		g_clearInkey();
	}
}

/*****************************************************************************
*								C
* Fvoid
* ߒlFuint8_t       ACe
*****************************************************************************/
static uint8_t search( void )
{
	char msg[64] ,key[32];
	uint8_t ret;
	uint16_t itemCount;

	key[0] = '\0';
	itemCount = 0;
	while ( itemCount == 0 ) {
	
		/* L[[h			*/
		g_cls();
		strcpy_P( msg ,PSTR("L[[h͂ĉ") );
		ret = g_inputText( G_OPAQUE ,msg ,key );
		if ( ret ) {								/* LZH			*/
			return ( 0 );
		}

		if ( !key[0] ) {
			g_msgBox_P( G_OPAQUE ,2 ,PSTR("L[[h͂Ă܂") ,1 );
			continue;
		}

		/* Đ~					*/
		g_msgBox_P( G_OPAQUE ,2 ,PSTR("EEE") ,0 );
		shoutcast_stop();

		/* L[[h			*/
		ret = shoutcast_stationSearch( key ,ADDR_pListBuffer ,SIZE_pListBuffer );
		if ( ret != 0 ) {
			sprintf_P( msg ,PSTR("G[ #%u ܂") ,ret );
			g_msgBox( G_OPAQUE ,1 ,msg ,1 );
			continue;
		}

		itemCount = shoutcast_stationItemCount( ADDR_pListBuffer );
		if ( itemCount == 0 ) {
			g_msgBox_P( G_OPAQUE ,1 ,PSTR("vXe[V܂") ,1 );
		}
	}

	return ( itemCount );
}

/*****************************************************************************
*							ʏ\
* Fuint8_t  i       ICfbNXԍ
*		uint8_t  pageMax Ly[W
* ߒlFvoid
*****************************************************************************/
static void disp_init( uint8_t i ,uint8_t pageMax )
{
	g_off();
	g_clearButton();							/* o^{^NA			*/
	g_textScrollEnable( 0 );					/* ebv\XV֎~		*/
	g_cls();									/* ʃNA				*/
	disp_list_menu_buttons( 0x73 );				/* e{^o^				*/

	shoutInfo->recvMetaData = 0;				/* ^\				*/
	disp_shout_title();

	g_buttonAllDraw();							/* o^{^\			*/

	/* ACe{^ijo^	*/
	uint16_t x = ITEM_BUTTON_X;
	uint16_t y = ITEM_BUTTON_Y;
	char buf[1];
	buf[0] = '\0';
	for ( uint8_t i = 0 ;i < PAGE_ITEM_MAX ;i++ ) {
		g_addButton( BUTTON_ITEM0 + i ,G_OPAQUE ,0 ,x ,y ,x + ITEM_BUTTON_WIDTH - 1 ,y + ITEM_BUTTON_HEIGHT - 1 ,buf ,0 ,0 );
		y += ( ITEM_BUTTON_HEIGHT + ITEM_BUTTON_STEP );
	}

	/* ŏ̃y[W\			*/
	disp_page( i ,pageMax );

	/* ʕ\						*/
	g_on();
	g_clearInkey();
}

/*****************************************************************************
*						wCfbNX܂ރy[W\
* Fuint8_t index   \CfbNX
*		uint8_t pageMax Ly[W
* ߒlFvoid
*****************************************************************************/
static void disp_page( uint8_t index ,uint8_t pageMax )
{
	uint8_t page;
	uint8_t j;
	char buf[8];

	/* 1y[W̃ACe\	*/
	page = index / PAGE_ITEM_MAX;
	j = page * PAGE_ITEM_MAX;
	for ( uint8_t i = 0 ;i < PAGE_ITEM_MAX ;i++ ,j++ ) {
		disp_item( j ,index == j );
	}

	/* y[Wԍ\			*/
	g_puts_P( GMODE ,2 ,276 ,22 ,PSTR("page") ,RGB(255,255,255) ,RGB(0,0,0) );
	if ( pageMax > 0 ) {
		sprintf_P( buf ,PSTR("%2d/%2d") ,page + 1 ,pageMax );
	} else {
		strcpy_P( buf ,PSTR("--/--") );
	}
	g_puts( GMODE ,2 ,276 ,39 ,buf ,RGB(255,128,0) ,RGB(0,0,0) );
}

/*****************************************************************************
*						wCfbNX̃ACe\
* Fuint8_t index \CfbNX
*		uint8_t sw    0:I 1:I
* ߒlFvoid
*****************************************************************************/
static void disp_item( uint8_t index ,uint8_t sw )
{
	char name[27] ,br[4];
	char buf[8];
	uint16_t fColor ,bColor;
	uint16_t n;
	uint8_t sts = 0;

	uint16_t x = ITEM_BUTTON_X;
	uint16_t y = ITEM_BUTTON_Y + ( index % PAGE_ITEM_MAX ) * ( ITEM_BUTTON_HEIGHT + ITEM_BUTTON_STEP );

	PLAY_ISR_DISABLE();
	if ( shoutcast_stationItem( ADDR_pListBuffer ,index , SHOUTCAST_ITEM_NAME ,name ,sizeof(name) ) == 0 ) {
		if ( shoutcast_stationItem( ADDR_pListBuffer ,index , SHOUTCAST_ITEM_BR ,br ,sizeof(br) ) == 0 ) {
			sts = 1;
		}
	}
	PLAY_ISR_ENABLE();

	if ( sw ) {
		fColor = RGB( 255 ,255 ,255 );
		bColor = RGB(   0 ,  0 ,180 );
	} else {
		fColor = RGB( 255 ,255 ,128 );
		bColor = RGB(   0 , 64 , 64 );
	}

	g_boxF( G_OPAQUE ,x ,y ,x + ITEM_BUTTON_WIDTH - 1 ,y + ITEM_BUTTON_HEIGHT  - 1 ,bColor );

	sprintf_P( buf ,PSTR("%2d.") ,index + 1 );
	g_puts( G_OPAQUE ,2 ,x + 2 ,y + 4 ,buf ,fColor ,bColor );

	if ( sts ) {
		g_puts( G_OPAQUE ,2 ,x + 26 ,y + 4 ,name ,fColor ,bColor );

		atou16( br ,&n );
		sprintf_P( buf ,PSTR("%3uk") ,n );
		g_puts( G_OPAQUE ,1 ,x + ITEM_BUTTON_WIDTH - 25 ,y + 9 ,buf ,RGB(255,128,0) ,bColor );

	}
}

/*****************************************************************************
*					wCfbNX̃ACeI
* Fuint8_t index     CfbNX
* ߒlFvoid
*****************************************************************************/
static void tune( uint8_t index )
{
	char url[URL_SIZE] ,id[SHOUTCAST_ID_SIZE];
	char buf[48];
	uint8_t sts = 0;

	PLAY_ISR_DISABLE();
	uint8_t ret = shoutcast_stationItem( ADDR_pListBuffer ,index ,SHOUTCAST_ITEM_ID ,id ,sizeof(id) );
	PLAY_ISR_ENABLE();
	if ( ret || ( id[0] == '\0' ) ) {
		strcpy_s_P( buf ,sizeof(buf) ,PSTR("ACeo^ł") );

	} else {
		PLAY_ISR_DISABLE();
		player_sound( SOUND_TOP_OF_MUSIC );
		g_msgBox_P( G_OPAQUE ,2 ,PSTR("  ") ,0 );
		shoutcast_stop();

		/* PLSt@C擾			*/
		uint8_t ret = shoutcast_download_pls( id ,ADDR_pPlsBuffer ,SIZE_pPlsBuffer );
		if ( ret != 0 ) {
			strcpy_s_P( buf ,sizeof(buf) ,PSTR("PLŞق擾ł܂") );

		} else if ( shoutcast_pls_count( ADDR_pPlsBuffer ) == 0 ) {
			strcpy_s_P( buf ,sizeof(buf) ,PSTR("PLSт擾ł܂") );

		} else {
			shoutcast_pls_item( ADDR_pPlsBuffer ,0 ,sizeof(url) ,url );
			if ( url[0] == '\0' ) {
				strcpy_s_P( buf ,sizeof(buf) ,PSTR("ðURL擾ł܂") );
			} else {
				sts = 1;
			}
		}
	}

	/* I					*/
	if ( sts == 0 ) {
		g_msgBox( G_OPAQUE ,2 ,buf ,1 );
	} else {
		ss_strcpy_s( ADDR_pUrl ,SIZE_pUrl ,url );
		shoutcast_start();
	}
}


/*****************************************************************************
*					wCfbNX̃ACeo^(EEP)
* Fuint8_t index o^CfbNX
* ߒlFvoid
*****************************************************************************/
static void itemAdd( uint8_t index )
{
	char url[URL_SIZE] ,id[SHOUTCAST_ID_SIZE] ,name[SHOUTCAST_NAME_SIZE];
	char buf[48] ,br[SHOUTCAST_BR_SIZE];
	uint8_t n ,i;
	uint16_t brVal;

	uint8_t ret;
	int8_t sts = 0;

	PLAY_ISR_DISABLE();
	ret = shoutcast_stationItem( ADDR_pListBuffer ,index ,SHOUTCAST_ITEM_ID ,id ,sizeof(id) );
	if ( ret == 0 ) {
		ret = shoutcast_stationItem( ADDR_pListBuffer ,index ,SHOUTCAST_ITEM_BR ,br ,sizeof(br) );
	}
	PLAY_ISR_ENABLE();

	if ( ret || ( id[0] == '\0' ) ) {
		strcpy_s_P( buf ,sizeof(buf) ,PSTR("ACeo^ł") );

	} else if ( free_station( &n ) != 0 ) {
		strcpy_s_P( buf ,sizeof(buf) ,PSTR("Xgɋ󂫂܂") );

	} else {
		g_msgBox_P( G_OPAQUE ,2 ,PSTR("  ") ,0 );
		shoutcast_stop();
		shoutcast_stationItem( ADDR_pListBuffer ,index ,SHOUTCAST_ITEM_NAME ,name ,sizeof(name) );

		/* PLSt@C擾			*/
		ret = shoutcast_download_pls( id ,ADDR_pPlsBuffer ,SIZE_pPlsBuffer );
		if ( ret != 0 ) {
			strcpy_s_P( buf ,sizeof(buf) ,PSTR("PLŞق擾ł܂") );

		} else if ( shoutcast_pls_count( ADDR_pPlsBuffer ) == 0 ) {
			strcpy_s_P( buf ,sizeof(buf) ,PSTR("PLSт擾ł܂") );

		} else {
			shoutcast_pls_item( ADDR_pPlsBuffer ,0 ,sizeof(url) ,url );
			if ( url[0] == '\0' ) {
				strcpy_s_P( buf ,sizeof(buf) ,PSTR("ðURL擾ł܂") );
			} else if ( search_station( url ,&i ) == 0 ) {
				sprintf_P( buf ,PSTR("%uԂɓo^Ă܂") ,i + 1 );
			} else {
				sts = 1;
			}
		}
	}

	/* EEPɓo^			*/
	if ( sts ) {
		atou16( br ,&brVal );
		save_station( n ,url ,name ,brVal );
		sprintf_P( buf ,PSTR("%uԂɓo^܂") ,n + 1 );
	}

	shoutcast_start();
	g_msgBox( G_OPAQUE ,2 ,buf ,1 );
}
