/*############################################################################
#                                                                            #
#   		           SDJ[ht@C\							 #
#                                                                            #
############################################################################*/
#define __MENU100_C__
#include "project.h"
#include "myutil/timer.h"

#define PAGE_ITEM_MAX 7

/* ACe{^_W^TCY		*/
#define ITEM_BUTTON_X	     4
#define ITEM_BUTTON_Y		60
#define ITEM_BUTTON_WIDTH  264
#define ITEM_BUTTON_HEIGHT 	20
#define ITEM_BUTTON_STEP     1

#define BUTTON_ITEM0       200

/* [J֐vg^Cv錾			*/
static void disp_init( PLAYLIST *list ,uint8_t page ,uint8_t index );
static void disp_page( PLAYLIST *list ,uint8_t page ,uint8_t index );
static uint8_t disp_item( PLAYLIST *list ,uint8_t index ,uint8_t sw );
static uint8_t selectFile( PLAYLIST *list );

/*****************************************************************************
*							SDJ[ht@C\
* Fvoid
* ߒlFvoid
*****************************************************************************/
void menu100( void )
{
	PLAYLIST list;
	uint8_t ret;
	uint8_t page = 0;
	uint8_t pageMax = 0;

	if ( SD_INS() ) {
		g_msgBox_P( G_OPAQUE ,2 ,PSTR("rcJ[h}ł") ,1 );
		return;
	}

	/* SHOUTCAST[hF[gfBNg	*/
	if ( eep.playMode == SYSTEM_MODE_SHOUTCAST ) {

		char buf[32];
		buf[0] = '\0';

		PLAY_ISR_DISABLE();
		disk_initialize( 0 );
		f_mount( 0 ,&sys.fs );
		ret = playList_loadDir( &list ,buf );
		PLAY_ISR_ENABLE();

		if ( ret != 0 ) {
			g_msgBox_P( G_OPAQUE ,2 ,PSTR("rcJ[hփANZXł܂") ,1 );
			return;
		}

	/* ~[WbNv[[FĐXg		*/
	} else {
		memcpy( &list ,&playSys->playList ,sizeof(PLAYLIST) );
	}

	/* y[Wϐ						*/
	page = list.index / PAGE_ITEM_MAX;
	pageMax = ( list.count + PAGE_ITEM_MAX - 1 ) / PAGE_ITEM_MAX;

	/* ʍ쐬								*/
	disp_init( &list ,page ,list.index );

	/* C[v							*/
	sys.noProcessTimer = NOT_PROCESS_TIMEOUT;
	while ( !SD_INS() && sys.noProcessTimer ) {

		/* VXe^XN					*/
		system_task();

		/* ^b`L[擾					*/
		uint8_t key = g_inkey();
		if ( key == 0 ) {
			continue;
		}

		if ( key == BUTTON_CLOSE ) {				/* uCANCELv			*/
			break;

		} else if ( key == BUTTON_TUNE ) {			/* uENTERv			*/
			/* t@CȈ	*/
			if ( list.items[list.index].atb == '0' ) {
				uint8_t backup_mode = eep.playMode;
				ret = selectFile( &list );
				if ( backup_mode != eep.playMode ) {
					break;
				} else if ( ret ) {
					disp_init( &list ,page ,list.index );
				}

			/* fBNgړ						*/
			} else {
				PLAY_ISR_DISABLE();
				uint8_t ret = playList_moveChild( &list );
				PLAY_ISR_ENABLE();
				if ( ret != 0 ) {
					list.count = 0;
				}
				page = list.index / PAGE_ITEM_MAX;
				pageMax = ( list.count + PAGE_ITEM_MAX - 1 ) / PAGE_ITEM_MAX;
				disp_page( &list ,page ,list.index );
			}

		} else if ( key == BUTTON_BACK ) {				/* uBACKv				*/
			PLAY_ISR_DISABLE();
			uint8_t ret = playLIst_moveParents( &list );
			PLAY_ISR_ENABLE();
			if ( ret == 0 ) {
				page = list.index / PAGE_ITEM_MAX;
				pageMax = ( list.count + PAGE_ITEM_MAX - 1 ) / PAGE_ITEM_MAX;
				disp_page( &list ,page ,list.index );

			} else if ( ret != 1 ) {
				page = 0;
				pageMax = 0;
				list.count = 0;
				disp_page( &list ,page ,list.index );
			}

		} else if ( key == BUTTON_PAGE_DOWN ) {			/* uOy[Wv			*/
			if ( pageMax >= 2 ) {
				if ( --page >= pageMax ) {
					page = pageMax - 1;
				}
				list.index = page * PAGE_ITEM_MAX;
				disp_page( &list ,page ,list.index );
			}

		} else if ( key == BUTTON_PAGE_UP ) {			/* uy[Wv			*/
			if ( pageMax >= 2 ) {
				if ( ++page >= pageMax ) {
					page = 0;
				}
				list.index = page * PAGE_ITEM_MAX;
				disp_page( &list ,page ,list.index );
			}

		} else if ( ( key >= BUTTON_ITEM0 ) && ( key <= ( BUTTON_ITEM0 + PAGE_ITEM_MAX - 1 ) ) ) {	/* t@CACe	*/
			uint8_t idx = ( page * PAGE_ITEM_MAX ) + ( key - BUTTON_ITEM0 );
			if ( ( idx < list.count ) && ( list.index != idx ) ) {
				g_textScrollEnable( 0 );
				disp_item( &list ,list.index ,0 );
				list.index = idx;
				if ( disp_item( &list ,list.index ,1 ) == 0 ) {
					g_textScrollEnable( 1 );
				}
			}

		} else {
			continue;
		}

		g_clearInkey();
		sys.noProcessTimer = NOT_PROCESS_TIMEOUT;
	}
}

/*****************************************************************************
*							ʕ\
* FPLAYLIST *list ꗗobt@
*		uint8_t  page  \y[W
*       uint8_t  index I𒆂̃ACe
* ߒlFvoid
*****************************************************************************/
static void disp_init( PLAYLIST *list ,uint8_t page ,uint8_t index )
{
	g_off();
	g_clearButton();							/* o^{^NA			*/
	g_setSpectrumEnable( 0 );					/* XyAi\XV֎~		*/
	g_textScrollEnable( 0 );					/* ebv\XV֎~		*/
	g_cls();
	disp_list_menu_buttons( 0x79 );				/* e{^o^				*/

	/* ACe{^ijo^	*/
	uint16_t x = ITEM_BUTTON_X;
	uint16_t y = ITEM_BUTTON_Y;
	char buf[1];
	buf[0] = '\0';
	for ( uint8_t i = 0 ;i < PAGE_ITEM_MAX ;i++ ) {
		g_addButton( BUTTON_ITEM0 + i ,G_OPAQUE ,0 ,x ,y ,x + ITEM_BUTTON_WIDTH - 1 ,y + ITEM_BUTTON_HEIGHT - 1 ,buf ,0 ,0 );
		y += ( ITEM_BUTTON_HEIGHT + ITEM_BUTTON_STEP );
	}

	g_buttonAllDraw();							/* o^{^\			*/
	disp_page( list ,page ,index );				/* 1y[W\				*/
	g_on();
	g_clearInkey();
}

/*****************************************************************************
*							y[W\
* FPLAYLIST *list ꗗobt@
*		uint8_t  page  \y[W
*       uint8_t  index I𒆂̃ACe
* ߒlFvoid
*****************************************************************************/
static void disp_page( PLAYLIST *list ,uint8_t page ,uint8_t index )
{
	uint8_t i = page * PAGE_ITEM_MAX;
	uint8_t sw;
	uint8_t flg = 0;
	char buf[52];

	g_textScrollEnable( 0 );

	/* ACȅ		*/
	if ( i >= list->count ) {
		uint16_t y = ITEM_BUTTON_Y;
		for ( i = 0 ;i < PAGE_ITEM_MAX ;i++ ) {
			g_boxF( G_OPAQUE ,ITEM_BUTTON_X ,y ,ITEM_BUTTON_X + ITEM_BUTTON_WIDTH - 1 ,y + ITEM_BUTTON_HEIGHT - 1 ,RGB( 64 ,0 ,64 ) );
			y += ( ITEM_BUTTON_HEIGHT + ITEM_BUTTON_STEP );
		}
		strcpy_s_P( buf ,sizeof(buf) ,PSTR("\\\\ȃACe܂") );
		g_puts( G_OPAQUE ,2 ,ITEM_BUTTON_X + 12 ,ITEM_BUTTON_Y + ( ITEM_BUTTON_HEIGHT + ITEM_BUTTON_STEP ) * 3 + 2 ,buf ,RGB(255 ,255 ,0) ,RGB( 64 ,0 ,64 ) );

	/* y[W\				*/
	} else {
		for ( uint8_t j = 0 ;j < PAGE_ITEM_MAX ;j++ ,i++ ) {
			sw = ( index == i );
			disp_item( list ,i ,sw );
			if ( sw ) flg = 1;
		}
		if ( flg ) {
			g_textScrollEnable( 1 );
		}
	}

	/* pX\				*/
	g_boxF( G_OPAQUE ,4 ,208 ,315 ,227 ,RGB(0,64,0) );
	if ( list->path[0] == '\0' ) {
		strcpy_P( buf ,PSTR("[root]") );
	} else {
		buf[0] = '/';
		memcpy( &buf[1] ,list->path ,sizeof(buf) - 2 );
		buf[ sizeof(buf) - 1 ] = '\0';
	}
	g_puts( G_OPAQUE ,1 ,4 ,212 ,buf ,RGB(0,255,255) ,RGB(0,64,0) );

	/* y[Wԍ\			*/
	uint8_t pmax = ( list->count + PAGE_ITEM_MAX - 1 ) / PAGE_ITEM_MAX;
	g_puts_P( GMODE ,2 ,276 ,22 ,PSTR("page") ,RGB(255,255,255) ,RGB(0,0,0) );
	if ( pmax > 0 ) {
		sprintf_P( buf ,PSTR("%2d/%2d") ,page + 1 ,pmax );
	} else {
		strcpy_P( buf ,PSTR("--/--") );
	}
	g_puts( GMODE ,2 ,276 ,39 ,buf ,RGB(255,128,0) ,RGB(0,0,0) );
}

/*****************************************************************************
*						wCfbNX̃ACe\
* FPLAYLIST *list ꗗobt@
*       uint8_t  index \ACe
*		uint8_t sw     0:I 1:I
* ߒlFuint8_t        0:LȃACe\
*                      1:ȃACeɂ󔒂\
*****************************************************************************/
static uint8_t disp_item( PLAYLIST *list ,uint8_t index ,uint8_t sw )
{
	uint8_t icon;
	uint16_t x = ITEM_BUTTON_X;
	uint16_t y = ITEM_BUTTON_Y + ( ITEM_BUTTON_HEIGHT + ITEM_BUTTON_STEP ) * (uint16_t)( index % PAGE_ITEM_MAX );
	uint16_t bg ,fc;
	PLAY_FILE_TYPE typ;
	PLAY_LISTITEM *item;
	char lfn[LFN_LENGTH];
	char dos[PLAY_LIST_PATH_LEGNTH];
	uint8_t ret;

	if ( sw ) {
		bg = RGB( 255 ,64 ,255 );
		fc = RGB(   0 , 0 ,128 );
	} else {
		bg = RGB( 64 ,0 ,64 );
		fc = RGB( 255 ,255 ,255 );
	}

	g_boxF( G_OPAQUE ,x ,y ,x + ITEM_BUTTON_WIDTH - 1 ,y + ITEM_BUTTON_HEIGHT - 1 ,bg );
	if ( index < list->count ) {
		item = &list->items[ index ];

		if ( item->atb == '0' ) {						/* t@CH				*/
			typ = getPlayFileType( item->fname );
			if ( typ == F_PLS ) {
				icon = 7;
			} else {
				icon = 8;
			}
		} else {										/* fBNgH			*/
			icon = 9;
		}

		if ( sw ) {
			icon -= 3;
		}

		ret = playList_getItemName( list ,index ,dos );	/* 8.3^tpX擾	*/
		if ( ret == 0 ) {
			PLAY_ISR_DISABLE();
			ret = f_getLFN( dos ,lfn );					/* LFN擾					*/
			if ( ret == 0 ) {
				g_convSJIS( lfn ,sizeof(lfn) ,lfn , PR_UTF16_UTF8_SJIS );
			}
			PLAY_ISR_ENABLE();
		}

		g_image( icon ,G_OPAQUE ,RGB(0,0,0) ,x + 4 ,y + 2 ,x + 4 + 15 ,y + 1 + 15 );

		if ( sw ) {									/* IACȅꍇ̓ebv	*/
			g_puts_scroll( G_OPAQUE ,2 ,5 ,x + 26 ,y ,x + ITEM_BUTTON_WIDTH - 1 ,lfn ,fc ,bg );
		} else {
			lfn[29] = '\0';
			g_puts( G_OPAQUE ,2 ,x + 26 ,y + 1 ,lfn ,fc ,bg );
		}

		return ( 0 );
	}

	return ( 1 );
}

/*****************************************************************************
*						t@CȈ
* FPLAYLIST *list t@Cꗗ\
* ߒlFuint8_t        0:s\
*                      1:s\iʍĕ`Kvj
*                      2:ssi[hύXj
*****************************************************************************/
static uint8_t selectFile( PLAYLIST *list )
{
	uint8_t ret;
	char buf[ SIZE_pUrl ];

	if ( ( list->count == 0 ) || ( list->index >= list->count ) ) {
		return ( 0 );
	}

	/* ACe擾						*/
	PLAY_ISR_DISABLE();
	ret = playList_getItemName( list ,list->index ,buf );
	PLAY_ISR_ENABLE();
	if ( ret != 0 ) {
		g_msgBox_P( G_OPAQUE ,2 ,PSTR("ACe擾ł܂") ,1 );
		return ( 1 );
	}

	/* PLSt@CI				*/
	if ( getPlayFileType( list->items[list->index].fname ) == F_PLS ) {

		/* PLSt@C[h			*/
		PLAY_ISR_DISABLE();
		uint8_t ret = shoutcast_load_pls( buf ,ADDR_pPlsBuffer ,SIZE_pPlsBuffer );
		PLAY_ISR_ENABLE();
		if ( ret != 0 ) {
			g_msgBox_P( G_OPAQUE ,2 ,PSTR("SDJ[hɃANZXł܂") ,1 );
			return ( 1 );
		}

		/* PLSt@CACemF	*/
		PLAY_ISR_DISABLE();
		uint16_t itemCount = shoutcast_pls_count( ADDR_pPlsBuffer );
		PLAY_ISR_ENABLE();
		if ( itemCount == 0 ) {
			g_msgBox_P( G_OPAQUE ,2 ,PSTR("PLSt@CG[ł") ,1 );
			return ( 1 );
		}

		PLAY_ISR_DISABLE();

		/* SHOUTCAST[h̏								*/
		if ( eep.playMode == SYSTEM_MODE_SHOUTCAST ) {
			g_msgBox_P( G_OPAQUE ,2 ,PSTR("  ") ,0 );
			player_sound( SOUND_TOP_OF_MUSIC );
			shoutcast_pls_item( ADDR_pPlsBuffer ,0 ,sizeof(buf) ,buf );
			ss_strcpy_s( ADDR_pUrl ,SIZE_pUrl ,buf );
			shoutcast_start();
			return ( 1 );

		/* ~[WbNv[[[h̐؂ւ			*/
		} else {
			g_clearButton();			/* o^{^NA		*/
			g_textScrollEnable( 0 );	/* ebv\XV֎~	*/
			g_msgBox_P( G_OPAQUE ,2 ,PSTR("  ") ,0 );

			player_sound( SOUND_CHANGE_MODE );
			save_system_status();

			shoutcast_pls_item( ADDR_pPlsBuffer ,0 ,sizeof(buf) ,buf );
			ss_strcpy_s( ADDR_pUrl ,SIZE_pUrl ,buf );
			eep.playMode = SYSTEM_MODE_SHOUTCAST;

			return ( 2 );
		}

	/* yt@CI	*/
	} else {
		/* ~[WbNv[[̏						*/
		if ( eep.playMode == SYSTEM_MODE_MUSIC_PLAYER ) {
			player_sound( SOUND_TOP_OF_MUSIC );
			playList_fileItem( &playSys->playList ,buf );
			playSys->eepInfo.resume.mode = RESUME_NONE;
			player_play( PLAY_CURRENT );
			return ( 0 );

		/* SHOUTCAST̐؂ւ							*/
		} else {
			g_clearButton();			/* o^{^NA		*/
			g_textScrollEnable( 0 );	/* ebv\XV֎~	*/
			g_msgBox_P( G_OPAQUE ,2 ,PSTR("  ") ,0 );

			player_sound( SOUND_CHANGE_MODE );
			shoutcast_stop();
			save_system_status();

			playList_getItemName( list ,list->index ,buf );
			ss_strcpy_s( ADDR_pPlayFile ,SIZE_pPlayFile ,buf );

			eep.playMode = SYSTEM_MODE_MUSIC_PLAYER;
			return ( 2 );
		}
	}

	return ( 0xff );
}
