/*############################################################################
#                                                                            #
#   		           [h؂ւ                                    #
#                                                                            #
############################################################################*/
#define __MENU101_C__
#include "project.h"
#include "myutil/timer.h"

/* [J֐vg^Cv錾	*/
static void disp_init( void );

/*****************************************************************************
*								[h؂ւ
* Fvoid
* ߒlFvoid
*****************************************************************************/
void menu101( void )
{
	uint8_t backup_playMode = eep.playMode;
	uint8_t mode = eep.playMode;

	/* ʕ\						*/
	disp_init();

	/* C[v						*/
	sys.noProcessTimer = NOT_PROCESS_TIMEOUT;
	while ( sys.noProcessTimer ) {

		/* VXe^XN				*/
		system_task();

		/* ^b`L[擾				*/
		uint8_t key = g_inkey();
		if ( key == 0 ) {
			continue;
		}

		if ( key == BUTTON_CLOSE ) {					/* 		*/
			break;

		} else if ( key == BUTTON_CHG_SHOUTCAST ) {		/* SHOUTCAST	*/
			mode = SYSTEM_MODE_SHOUTCAST;
			break;

		} else if ( key == BUTTON_CHG_PLAYER ) {		/* PLAYER		*/
			mode = SYSTEM_MODE_MUSIC_PLAYER;
			break;

		} else if ( key == BUTTON_CHG_RADIO ) {			/* FM RADIO		*/
			mode = SYSTEM_MODE_FM_RADIO;
			break;

		} else {
			continue;
		}

		sys.noProcessTimer = NOT_PROCESS_TIMEOUT;
		g_clearInkey();
	}

	if ( mode != backup_playMode ) {
		PLAY_ISR_DISABLE();

		g_clearButton();
		g_setSpectrumEnable( 0 );
		g_textScrollEnable( 0 );
		g_msgBox_P( G_OPAQUE ,2 ,PSTR("  ") ,0 );

		player_sound( SOUND_CHANGE_MODE );
		save_system_status();

		eep.playMode = mode;
	}
}

/*****************************************************************************
*							ʏ\
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void disp_init( void )
{
	char buf[1];
	buf[0] = '\0';

	g_off();
	g_clearButton();							/* o^{^NA			*/
	g_setSpectrumEnable( 0 );					/* XyAi\XV֎~		*/
	g_textScrollEnable( 0 );					/* ebv\XV֎~		*/
	g_cls();									/* ʃNA				*/
	g_addButton( BUTTON_CLOSE ,GMODE ,0 ,256 ,176 ,303 ,239 ,buf ,252 ,253 );	/* {^	*/
	disp_mode_change_buttons();					/* [h`FW{^o^	*/
	g_buttonAllDraw();							/* o^{^\			*/
	g_puts_P( GMODE ,2 ,72 ,32 ,PSTR("lncd@bg`mfd") ,RGB(255,128,0) ,RGB(0,0,0) );
	g_puts_P( GMODE ,2 ,BUTTON_CHG_SHOUTCAST_X - 16 ,128 ,PSTR("SHOUTcast") ,RGB(0,128,255) ,RGB(0,0,0) );
	g_puts_P( GMODE ,2 ,BUTTON_CHG_PLAYER_X - 24 ,128 ,PSTR("MUSIC PLAYER") ,RGB(0,128,255) ,RGB(0,0,0) );
	g_puts_P( GMODE ,2 ,BUTTON_CHG_RADIO_X - 8 ,128 ,PSTR("FM RADIO")      ,RGB(0,128,255) ,RGB(0,0,0) );
	g_on();
	g_clearInkey();
}
