/*############################################################################
#                                                                            #
#   		           		lbg[Nݒ                             #
#                                                                            #
############################################################################*/
#define __MENU102_C__
#include "project.h"
#include "myutil/timer.h"

/* lbg[NݒACe_W^TCY	*/
#define NET_BUTTON_X	       4
#define NET_BUTTON_Y		   8
#define NET_BUTTON_WIDTH     312
#define NET_BUTTON_HEIGHT     17
#define NET_BUTTON_STEP        1				/* {^Ԋu			*/

/* [J֐vg^Cv錾	*/
static void disp_init( void );
static void disp_net( uint8_t mode );
static void input_net( uint8_t btn );

/*****************************************************************************
*							lbg[Nݒ
* Fvoid
* ߒlFvoid
*****************************************************************************/
void menu102( void )
{
	/* ʕ\						*/
	disp_init();

	/* C[v						*/
	sys.noProcessTimer = NOT_PROCESS_TIMEOUT;
	while ( sys.noProcessTimer ) {

		/* VXe^XN				*/
		system_task();

		/* lbg[Np[^\	*/
		disp_net( 1 );

		/* ^b`L[擾				*/
		uint8_t key = g_inkey();
		if ( key == 0 ) {
			continue;
		}

		if ( key == BUTTON_CLOSE ) {					/* 		*/
			break;

		} else if ( ( key >= BUTTON_MAC ) && ( key <= BUTTON_DHCP ) ) {
			input_net( key );
			disp_init();

		} else {
			continue;
		}

		sys.noProcessTimer = NOT_PROCESS_TIMEOUT;
		g_clearInkey();
	}
}

/*****************************************************************************
*							ʏ\
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void disp_init( void )
{
	char buf[32];
	buf[0] = '\0';

	g_off();
	g_clearButton();							/* o^{^NA			*/
	g_setSpectrumEnable( 0 );					/* XyAi\XV֎~		*/
	g_textScrollEnable( 0 );					/* ebv\XV֎~		*/
	g_cls();									/* ʃNA				*/
	g_addButton( BUTTON_CLOSE ,GMODE ,0 ,256 ,176 ,303 ,239 ,buf ,252 ,253 );	/* {^	*/
	g_buttonAllDraw();							/* o^{^\			*/
	disp_net( 0 );

	g_puts_P( GMODE ,1 , 4 ,215 ,PSTR("version") ,RGB(255,255,255) ,RGB(0,0,0) );
	g_puts_P( GMODE ,1 ,58 ,215 ,PSTR(VERSION) ,RGB(255,150,0) ,RGB(0,0,0) );

	g_on();
	g_clearInkey();
}

/*****************************************************************************
*							lbg[Np[^\
* Fuint8_t mode 0F\@1FXV\
* ߒlFvoid
*****************************************************************************/
static void disp_net( uint8_t mode )
{
	static uint8_t back_dhcp_status = 0xff;
	static uint32_t back_ipTimer = 0;

	const uint16_t bgColor = 0x0000;
	uint16_t x ,y;

	char buf[64];
	uint32_t ip;
	uint8_t mac[6];

	if ( mode == 0 ) {
		x = NET_BUTTON_X;
		y = NET_BUTTON_Y;
		buf[0] = '\0';

		/* uMACAhXvږ\		*/
		g_boxF( GMODE ,x ,y ,x + NET_BUTTON_WIDTH - 1 ,y + NET_BUTTON_HEIGHT - 1 ,bgColor );
		g_puts_P( GMODE ,2 ,x + 4 ,y + 1 ,PSTR("MAC address") ,RGB(255,255,255) ,bgColor );
		g_addButton( BUTTON_MAC ,GMODE ,2 ,x + 120 ,y + 1 ,x + 135 ,y + 16 ,buf ,211 ,210 );
		y += ( NET_BUTTON_HEIGHT + NET_BUTTON_STEP );

		/* uzXgvږ\			*/
		g_boxF( GMODE ,x ,y ,x + NET_BUTTON_WIDTH - 1 ,y + NET_BUTTON_HEIGHT - 1 ,bgColor );
		g_puts_P( GMODE ,2 ,x + 4 ,y + 1 ,PSTR("host name") ,RGB(255,255,255) ,bgColor );
		if ( netInfo.dhcpMode == IP_DYNAMIC ) g_addButton( BUTTON_HOST ,GMODE ,2 ,x + 120 ,y + 1 ,x + 135 ,y + 16 ,buf ,211 ,210 );
		y += ( NET_BUTTON_HEIGHT + NET_BUTTON_STEP );

		/* uIPAhXvږ\			*/
		g_boxF( GMODE ,x ,y ,x + NET_BUTTON_WIDTH - 1 ,y + NET_BUTTON_HEIGHT - 1 ,bgColor );
		g_puts_P( GMODE ,2 ,x + 4 ,y + 1 ,PSTR("ip address") ,RGB(255,255,255) ,bgColor );
		if ( netInfo.dhcpMode == IP_STATIC ) g_addButton( BUTTON_IP ,GMODE ,2 ,x + 120 ,y + 1 ,x + 135 ,y + 16 ,buf ,211 ,210 );
		y += ( NET_BUTTON_HEIGHT + NET_BUTTON_STEP );

		/* uTulbgvږ\			*/
		g_boxF( GMODE ,x ,y ,x + NET_BUTTON_WIDTH - 1 ,y + NET_BUTTON_HEIGHT - 1 ,bgColor );
		g_puts_P( GMODE ,2 ,x + 4 ,y + 1 ,PSTR("subnet mask") ,RGB(255,255,255) ,bgColor );
		if ( netInfo.dhcpMode == IP_STATIC ) g_addButton( BUTTON_SUBNET ,GMODE ,2 ,x + 120 ,y + 1 ,x + 135 ,y + 16 ,buf ,211 ,210 );
		y += ( NET_BUTTON_HEIGHT + NET_BUTTON_STEP );

		/* uQ[gEGCvږ\		*/
		g_boxF( GMODE ,x ,y ,x + NET_BUTTON_WIDTH - 1 ,y + NET_BUTTON_HEIGHT - 1 ,bgColor );
		g_puts_P( GMODE ,2 ,x + 4 ,y + 1 ,PSTR("gate way address") ,RGB(255,255,255) ,bgColor );
		if ( netInfo.dhcpMode == IP_STATIC ) g_addButton( BUTTON_GATEWAY ,GMODE ,2 ,x + 120 ,y + 1 ,x + 135 ,y + 16 ,buf ,211 ,210 );
		y += ( NET_BUTTON_HEIGHT + NET_BUTTON_STEP );

		/* uDNSvږ\				*/
		g_boxF( GMODE ,x ,y ,x + NET_BUTTON_WIDTH - 1 ,y + NET_BUTTON_HEIGHT - 1 ,bgColor );
		g_puts_P( GMODE ,2 ,x + 4 ,y + 1 ,PSTR("dns address") ,RGB(255,255,255) ,bgColor );
		if ( netInfo.dhcpMode == IP_STATIC ) g_addButton( BUTTON_DNS ,GMODE ,2 ,x + 120 ,y + 1 ,x + 135 ,y + 16 ,buf ,211 ,210 );
		y += ( NET_BUTTON_HEIGHT + NET_BUTTON_STEP );

		/* uNTP NAMEvږ\			*/
		g_boxF( GMODE ,x ,y ,x + NET_BUTTON_WIDTH - 1 ,y + NET_BUTTON_HEIGHT - 1 ,bgColor );
		g_puts_P( GMODE ,2 ,x + 4 ,y + 1 ,PSTR("ntp url") ,RGB(255,255,255) ,bgColor );
		if ( netInfo.dhcpMode != IP_STATIC ) g_addButton( BUTTON_NTP ,GMODE ,2 ,x + 120 ,y + 1 ,x + 135 ,y + 16 ,buf ,211 ,210 );
		y += ( NET_BUTTON_HEIGHT + NET_BUTTON_STEP );

		/* uŏIvږ\		*/
		g_boxF( GMODE ,x ,y ,x + NET_BUTTON_WIDTH - 1 ,y + NET_BUTTON_HEIGHT - 1 ,bgColor );
		g_puts_P( GMODE ,2 ,x + 4 ,y + 1 ,PSTR("ntp last update") ,RGB(255,255,255) ,bgColor );
		y += ( NET_BUTTON_HEIGHT + NET_BUTTON_STEP );

		/* uDHCPXe[^Xvږ\		*/
		g_boxF( GMODE ,x ,y ,x + NET_BUTTON_WIDTH - 1 ,y + NET_BUTTON_HEIGHT - 1 ,bgColor );
		g_puts_P( GMODE ,2 ,x + 4 ,y + 1 ,PSTR("dhcp status") ,RGB(255,255,255) ,bgColor );
		g_addButton( BUTTON_DHCP ,GMODE ,2 ,x + 120 ,y + 1 ,x + 135 ,y + 16 ,buf ,211 ,210 );
		y += ( NET_BUTTON_HEIGHT + NET_BUTTON_STEP );

		/* o^{^\							*/
		g_buttonAllDraw();

		/* r\									*/
		x = NET_BUTTON_X;
		y = NET_BUTTON_Y;
		for ( uint8_t i = 0 ;i < 9 ;i++ ) {		
			g_box( GMODE ,x ,y + NET_BUTTON_HEIGHT ,x + NET_BUTTON_WIDTH - 1 ,y + NET_BUTTON_HEIGHT ,RGB( 128 ,128 ,128 ) );
			y += ( NET_BUTTON_HEIGHT + NET_BUTTON_STEP );
		}

		netInfo.update = 1;
		ntpcInfo.update = 1;
		back_dhcp_status = 0xff;
	}

	if ( mode == 1 ) {
		if ( netInfo.update ) {
			netInfo.update = 0;

			x = NET_BUTTON_X;
			y = NET_BUTTON_Y;
			for ( uint8_t i = 0 ;i < 8 ;i++ ) {		
				g_boxF( GMODE ,x + 144 ,y ,x + NET_BUTTON_WIDTH - 1 ,y + NET_BUTTON_HEIGHT - 1 ,bgColor );
				y += ( NET_BUTTON_HEIGHT + NET_BUTTON_STEP );
			}

			x = NET_BUTTON_X + 144;
			y = NET_BUTTON_Y;

			/* uMACAhXv\				*/
			wiz_getSHAR( mac );
			sprintf_P( buf ,PSTR("%02X-%02X-%02X-%02X-%02X-%02X") ,mac[0] ,mac[1] ,mac[2] ,mac[3] ,mac[4] ,mac[5] );
			g_puts( GMODE ,2 ,x + 4 ,y + 1 ,buf ,RGB(255,128,0) ,bgColor );
			y += ( NET_BUTTON_HEIGHT + NET_BUTTON_STEP );

			/* uzXgv\					*/
			if ( netInfo.dhcpMode == IP_DYNAMIC ) g_puts( GMODE ,2 ,x + 4 ,y + 1 ,netInfo.hostname ,RGB(255,128,0) ,bgColor );
			y += ( NET_BUTTON_HEIGHT + NET_BUTTON_STEP );

			if ( ( netInfo.netInit == 0xff ) || ( netInfo.dhcpMode == IP_STATIC ) ) {

				/* uIPAhXv\					*/
				wiz_getSIPR( (uint8_t *)&ip );
				g_puts( GMODE ,2 ,x + 4 ,y + 1 ,inet_ntoa( ip ) ,RGB(255,128,0) ,bgColor );
				y += ( NET_BUTTON_HEIGHT + NET_BUTTON_STEP );

				/* uTulbgv\					*/
				wiz_getSUBR( (uint8_t *)&ip );
				g_puts( GMODE ,2 ,x + 4 ,y + 1 ,inet_ntoa( ip ) ,RGB(255,128,0) ,bgColor );
				y += ( NET_BUTTON_HEIGHT + NET_BUTTON_STEP );

				/* uQ[gEGCv\					*/
				wiz_getGAR( (uint8_t *)&ip );
				g_puts( GMODE ,2 ,x + 4 ,y + 1 ,inet_ntoa( ip ) ,RGB(255,128,0) ,bgColor );
				y += ( NET_BUTTON_HEIGHT + NET_BUTTON_STEP );

				/* uDNSv\							*/
				g_puts( GMODE ,2 ,x + 4 ,y + 1 ,inet_ntoa( netInfo.dns ) ,RGB(255,128,0) ,bgColor );
				y += ( NET_BUTTON_HEIGHT + NET_BUTTON_STEP );

				/* uNTP NAMEv\						*/
				if ( netInfo.dhcpMode == IP_DYNAMIC ) g_puts( GMODE ,2 ,x + 4 ,y + 1 ,netInfo.ntpname ,RGB(255,128,0) ,bgColor );
				y += ( NET_BUTTON_HEIGHT + NET_BUTTON_STEP );
			}
		}

		if ( ntpcInfo.update ) {
			ntpcInfo.update = 0;

			x = NET_BUTTON_X;
			y = NET_BUTTON_Y + ( NET_BUTTON_HEIGHT + NET_BUTTON_STEP ) * 7;
			g_boxF( GMODE ,x + 144 ,y ,x + NET_BUTTON_WIDTH - 1 ,y + NET_BUTTON_HEIGHT - 1 ,bgColor );

			/* uŏIv\					*/
			if ( ( netInfo.netInit == 0xff ) && ( netInfo.dhcpMode == IP_DYNAMIC ) ) {
				x = NET_BUTTON_X + 144;
				TIME t;
				ntpc_getLastUpdate( &t );
				sprintf_P( buf ,PSTR("%4u/%2u/%2u %02u:%02u:%02u") ,t.year ,t.month ,t.day ,t.hour ,t.minute ,t.second );
				g_puts( GMODE ,2 ,x + 4 ,y + 1 ,buf ,RGB(255,128,0) ,bgColor );
			}
		}

		/* uDHCPXe[^Xv\				*/
		if ( ( back_dhcp_status != dhcpInfo.status ) || ( ( dhcpInfo.status == DHCP_STS_LEASED ) && ( back_ipTimer != dhcpInfo.ipTimer ) ) ) {
			back_dhcp_status = dhcpInfo.status;

			x = NET_BUTTON_X + 144;
			y = NET_BUTTON_Y + ( NET_BUTTON_HEIGHT + NET_BUTTON_STEP ) * 8;

			if ( netInfo.dhcpMode == IP_STATIC ) {
				strcpy_s_P( buf ,sizeof(buf) ,PSTR("disable            ") );

			} else if ( dhcpInfo.status == DHCP_STS_DISCOVER ) {
				strcpy_s_P( buf ,sizeof(buf) ,PSTR("DISCOVER           ") );

			} else if ( dhcpInfo.status == DHCP_STS_REQUEST ) {
				strcpy_s_P( buf ,sizeof(buf) ,PSTR("REQUEST            ") );

			} else if ( dhcpInfo.status == DHCP_STS_LEASED ) {
				back_ipTimer = dhcpInfo.ipTimer;
				if ( dhcpInfo.ipTimer == 0xffffffff ) {
					strcpy_s_P( buf ,sizeof(buf) ,PSTR("LEASED             ") );
				} else {
					sprintf_P( buf ,PSTR("LEASED (%3u:%02u:%02u )") ,(uint16_t)( dhcpInfo.ipTimer / 3600L ) ,(uint16_t)( ( dhcpInfo.ipTimer % 3600L ) / 60L ) ,(uint16_t)( dhcpInfo.ipTimer % 60L ) );
				}

			} else if ( dhcpInfo.status == DHCP_STS_REREQUEST ) {
				strcpy_s_P( buf ,sizeof(buf) ,PSTR("REREQUEST          ") );

			} else {
				strcpy_s_P( buf ,sizeof(buf) ,PSTR("                   ") );
			}
			g_puts( GMODE ,2 ,x + 4 ,y + 1 ,buf ,RGB(255,128,0) ,bgColor );

		}
	}
}

/*****************************************************************************
*						lbg[Np[^͉
* Fuint8_t    btn  ύXp[^ BUTTON_MAC / BUTTON_HOST / BUTTON_IP
*									   BUTTON_SUBNET / BUTTON_GATEWAY
*                                      BUTTON_DNS / BUTTON_NTP / BUTTON_DHCP
* ߒlFvoid
*****************************************************************************/
static void input_net( uint8_t btn )
{
	char msg[64] ,val[32] ,err[64];
	char nval[32];
	NET_CONFIG net;

	g_clearButton();									/* o^{^NA		*/
	g_setSpectrumEnable( 0 );							/* XyAi\XV֎~	*/
	g_textScrollEnable( 0 );							/* ebv\XV֎~	*/
	g_cls();

	memcpy( &net ,&netInfo ,sizeof(NET_CONFIG) );

	/* DHCP؂ւ				*/
	if ( btn == BUTTON_DHCP ) {
		if ( netInfo.dhcpMode == IP_STATIC ) {
			if ( g_msgBox_P( G_OPAQUE ,2 ,PSTR("DHCPLɂ܂H") ,3 ) != 1 ) {
				return;
			}
			net.dhcpMode = IP_DYNAMIC;

		} else {
			if ( g_msgBox_P( G_OPAQUE ,2 ,PSTR("DHCP𖳌ɂ܂H") ,3 ) != 1 ) {
				return;
			}
			net.dhcpMode = IP_STATIC;
		}

	} else {

		/* ͍ڃf[^쐬		*/
		if ( btn == BUTTON_MAC ) {
			strcpy_s_P( msg ,sizeof(msg) ,PSTR("MACڽxx-xx-xx-xx-xx-xx^œ͂ĉ") );
			sprintf_P( val ,PSTR("%02X-%02X-%02X-%02X-%02X-%02X") ,net.mac[0] ,net.mac[1] ,net.mac[2] ,net.mac[3] ,net.mac[4] ,net.mac[5] );

		} else if ( btn == BUTTON_HOST ) {
			strcpy_s_P( msg ,sizeof(msg) ,PSTR("νĖ15ȓœ͂ĉ") );
			strcpy_s( val ,sizeof(val) ,net.hostname );

		} else if ( btn == BUTTON_IP ) {
			strcpy_s_P( msg ,sizeof(msg) ,PSTR("IPڽxxx.xxx.xxx.xxx^œ͂ĉ") );
			strcpy_s( val ,sizeof(val) ,inet_ntoa( net.ip ) );

		} else if ( btn == BUTTON_SUBNET ) {
			strcpy_s_P( msg ,sizeof(msg) ,PSTR("ȯϽxxx.xxx.xxx.xxx^œ͂ĉ") );
			strcpy_s( val ,sizeof(val) ,inet_ntoa( net.subnet ) );

		} else if ( btn == BUTTON_GATEWAY ) {
			strcpy_s_P( msg ,sizeof(msg) ,PSTR("ްĳڽxxx.xxx.xxx.xxx^œ͂ĉ") );
			strcpy_s( val ,sizeof(val) ,inet_ntoa( net.gateway ) );

		} else if ( btn == BUTTON_DNS ) {
			strcpy_s_P( msg ,sizeof(msg) ,PSTR("DNSްڽxxx.xxx.xxx.xxx^œ͂ĉ") );
			strcpy_s( val ,sizeof(val) ,inet_ntoa( net.dns ) );

		} else if ( btn == BUTTON_NTP ) {
			strcpy_s_P( msg ,sizeof(msg) ,PSTR("NTPްURL͂ĉB(IPڽ)") );
			strcpy_s( val ,sizeof(val) ,net.ntpname );
		}

		/* f[^				*/
		strcpy_s( nval ,sizeof(nval) ,val );
		while ( 1 ) {
			if ( g_inputText( G_OPAQUE ,msg ,val ) != 0 ) return;	/* LZH			*/

			err[0] = '\0';
			if ( !val[0] ) {
				strcpy_s_P( err ,sizeof(err) ,PSTR("l͂Ă܂") );

			} else if ( btn == BUTTON_MAC ) {
				if ( mac_addr( val ,net.mac ) != 0 ) {
					strcpy_s_P( err ,sizeof(err) ,PSTR("MACڽ̓͂ɊԈႢ܂") );
				}

			} else if ( btn == BUTTON_HOST ) {
				if ( strlen( val ) > 15 ) {
					strcpy_s_P( err ,sizeof(err) ,PSTR("νĖ16ȏ͐ݒł܂") );
				} else if ( strchr( val ,'.' ) != NULL ) {
					strcpy_s_P( err ,sizeof(err) ,PSTR("νĖصނ܂߂鎖͂ł܂") );
				} else if ( ( val[0] >= '0' ) && ( val[0] <= '9' ) ) {
					strcpy_s_P( err ,sizeof(err) ,PSTR("νĖ̐擪ɐ͎gpł܂") );
				} else {
					strcpy_s( net.hostname ,sizeof(net.hostname) ,val );
				}

			} else if ( btn == BUTTON_IP ) {
				net.ip = inet_addr( val );
				if ( net.ip == 0L ) {
					strcpy_s_P( err ,sizeof(err) ,PSTR("IPڽ̓͂ɊԈႢ܂") );
				}

			} else if ( btn == BUTTON_SUBNET ) {
				net.subnet = inet_addr( val );
				if ( net.subnet == 0L ) {
					strcpy_s_P( err ,sizeof(err) ,PSTR("ȯϽڽ̓͂ɊԈႢ܂") );
				}

			} else if ( btn == BUTTON_GATEWAY ) {
				net.gateway = inet_addr( val );
				if ( net.gateway == 0L ) {
					strcpy_s_P( err ,sizeof(err) ,PSTR("ްĳڽ̓͂ɊԈႢ܂") );
				}

			} else if ( btn == BUTTON_DNS ) {
				net.dns = inet_addr( val );
				if ( net.dns == 0L ) {
					strcpy_s_P( err ,sizeof(err) ,PSTR("DNSްڽ̓͂ɊԈႢ܂") );
				}

			} else if ( btn == BUTTON_NTP ) {
				if ( !isDomain( val ) ) {
					strcpy_s_P( err ,sizeof(err) ,PSTR("NTPްURL̓͂ɊԈႢ܂") );
				} else {
					strcpy_s( net.ntpname ,sizeof(net.ntpname) ,val );
				}
			}

			if ( err[0] ) {
				g_msgBox( G_OPAQUE ,1 ,err ,1 );
			} else if ( strcmp( nval ,val ) != 0 ) {
				if ( g_msgBox_P( G_OPAQUE ,1 ,PSTR("͂lɕύX܂H") ,3 ) == 1 ) break;
			} else {
				return;
			}
		}
	}

	/* lbg[Np[^ۑZbg	*/
	PLAY_ISR_DISABLE();
	g_msgBox_P( G_OPAQUE ,2 ,PSTR("  ") ,0 );
	save_system_status();
	save_netInfo( &net );
	g_msgBox_P( G_OPAQUE ,2 ,PSTR("VXeZbg܂") ,1 );

	/* fW^AvVbg_E	*/
	ENABLE_AMP_MUTE();
	WAIT_MS( 100 );
	ENABLE_AMP_SHUTDOWN();
	
	mcu_soft_reset();						/* Zbg	*/
}
