/*###########################################################################
#                                                                           #
#  			        	v[[W[                                #
#                                                                           #
###########################################################################*/
#define __PLAYER_C__
#include "project.h"

#define TIMER_NUM 3					/* WAIT_MS()Ŏgp^C}[ԍ		*/
#include "myutil/timer.h"

#define wdt_reset()

/* MIDIĐ̒萔`		*/
#define SDI_SIZE 2048				/* DSPSDIobt@TCY(Œ)		*/

/* O[oϐ			*/
PLAYER_SYS *playSys = NULL;

/*****************************************************************************
*							Đ^XN
* Fvoid
* ߒlFvoid
*****************************************************************************/
void player_task( void )
{
	uint16_t n = 0;

	/* DSPփt@C]							*/
	if ( playSys->playMode == PLAY_STS_PLAYING ) {
		/* MIDIt@CĐDSP̃obt@\	*/
		if ( ( playSys->playInfo.type == F_MIDI ) && VS_GET_DREQ() ) {
			uint32_t i = vsReadXmemDword( X_BYTES_LEFT );
			if ( i ) {
				i -= ( playSys->playFL.fsize - playSys->playFL.fptr );
				playSys->dspBusy = (uint8_t)( i > ( SDI_SIZE / 2 ) );
			}
		}

		if ( ( playSys->playFL.fptr < playSys->playFL.fsize ) && !playSys->dspBusy ) {
			if ( f_forward( (FIL *)&playSys->playFL ,vsOutStream ,256 ,&n ) != FR_OK ) {
				playSys->playMode = PLAY_STS_ERROR;
				PLAY_ISR_DISABLE();
			}
		}

		/* t@CŌ܂œ]ꍇ̓t@CiCY	*/
		if ( playSys->playFL.fptr >= playSys->playFL.fsize ) {
			playSys->playMode = PLAY_STS_FAINARAIZ;
			playSys->fainaraizStep = 0;
		}
	}

	/* t@CiCY									*/
	if ( playSys->playMode == PLAY_STS_FAINARAIZ ) {
		switch ( playSys->fainaraizStep ) {

			/* Step 0 : ݒ							*/
			case 0:
				if ( VS_GET_DREQ() ) {
					playSys->endFillByte = (uint8_t)( vsReadXmem( playSys->endFillByte ) & 0x00ff );
					playSys->endFillByteCounter = 2080;
					playSys->fainaraizStep = 101;
				}
				break;

			/* Step 1 : SM_CANCELs						*/
			case 1:
				if ( VS_GET_DREQ() ) {
					vsRegWrite( SCI_MODE ,vsRegRead( SCI_MODE ) | SM_CANCEL );
					playSys->endFillByteCounter = 2048;
					playSys->fainaraizStep = 102;
				}
				break;

			/* Step 2 : SM_CANCELs̊mF				*/
			case 2:
				n = 0;					/* XyAis[Nl^XyAil ALL 0 ܂ŃX[*/
				for ( uint8_t i = 0 ;i < VS_SPECTRUM_VALUES ;i++ ) {
					if ( sys.dsp_sp[i] ) {
						n = 1;
						break;
					}
				}

				if ( !n && VS_GET_DREQ() ) {
					if ( vsRegRead( SCI_HDAT0 ) || vsRegRead( SCI_HDAT1 ) ) {
						vsResetPlayMode();
					}
					f_close( &playSys->playFL );
					playSys->fainaraizStep = 0;
					playSys->playMode = PLAY_STS_FINISH; 
				}
				break;

			/* Step 101 , 102 : playInfo.endFillByte𑗐M			*/
			case 101:
			case 102:
				if ( playSys->endFillByteCounter == 0 ) {
					if ( playSys->fainaraizStep == 101 ) {
						playSys->fainaraizStep = 1;
					} else {
						playSys->fainaraizStep = 2;
					}

				} else {
					if ( ( playSys->playInfo.type == F_MIDI ) && VS_GET_DREQ() ) {
						uint16_t i = (uint16_t)vsReadXmemDword( X_BYTES_LEFT );
						if ( i > 12 ) {				/* 12̍			*/
							n = 0;
						} else {
							n = 1;
						}
					} else {
						n = 32;
					}

					if ( playSys->endFillByteCounter < n ) {
						n = playSys->endFillByteCounter;
					}

					if ( n && VS_GET_DREQ() ) {
						playSys->endFillByteCounter -= vsOutFill( playSys->endFillByte ,n );
					}
				}
				break;

			default:
				break;
		}
	}
}

/*****************************************************************************
*								v[[
* FPLAYER *p Ǘ\̂ւ̃|C^
* ߒlFvoid
*****************************************************************************/
void player_init( PLAYER_SYS *p )
{
	PLAY_ISR_DISABLE();
	playSys = p;
	memset( playSys ,0x00 ,sizeof(PLAYER_SYS) );
	playSys->sd_ins = 0xff;
}

/*****************************************************************************
*						v[[̃obNOh
* Fvoid
* ߒlFPLAYER_STS v[[Xe[^X( PLAY_STS_NONE == ԕω )
*****************************************************************************/
PLAYER_STS player_poll( void )
{
	uint8_t ret;
	uint8_t update = 0;

	/* DSP]̃G[				*/
	if ( playSys->playMode == PLAY_STS_ERROR ) {
		strcpy_P( playSys->playInfo.text.textBuffer ,PSTR("rcJ[hɃANZXł܂") );
		player_stop();
		playSys->erroring = 1;
		update = 1;
	}

	/* SDJ[hԕω̏			*/
	ret = SD_INS();
	if ( playSys->sd_ins != ret ) {
		playSys->sd_ins = ret;

		if ( playSys->sd_ins ) {					/* }}H				*/
			playSys->erroring = 1;
			player_stop();
			playSys->playMode = PLAY_STS_NOT_INSERT;
			strcpy_P( playSys->playInfo.text.textBuffer ,PSTR("rcJ[h}Ă܂") );
			update = 1;

		} else {									/* }}H				*/
			disk_initialize( 0 );
			f_mount( 0 ,&sys.fs );

			/* W[p[^LAW[݂					*/
			ret = 1;
			if ( playSys->eepInfo.resume.mode != RESUME_NONE ) {
				ret = playList_fileItem( &playSys->playList ,playSys->eepInfo.resume.fname );
			}

			/* W[s͖͐擪̃ACe擾					*/
			if ( ret != 0 ) {
				ret = playList_findFastItem( &playSys->playList );
				if ( ret == 0 ) {
					playSys->eepInfo.resume.mode = RESUME_TOP;
				}
			}

			/*@W[sE[gfBNg擾s̏ꍇ̓G[Ƃ	*/
			if ( ret ) {
				playSys->playMode = PLAY_STS_ACCESS_ERROR;
				strcpy_P( playSys->playInfo.text.textBuffer ,PSTR("SDJ[hփANZXłȂt@C܂") );
				playSys->erroring = 1;
				update = 1;

			/* ĐJn															*/
			} else {
				update = 1;
				ret = player_play( PLAY_CURRENT );
				if ( ( ret != PLAY_STS_PLAYING ) && ( ret != PLAY_STS_NOT_SYPPORT ) ) {
					playSys->erroring = 1;
				} else {
					playSys->erroring = 0;
				}
			}
		}

	} else if ( playSys->sd_ins == 0 ) {
		if ( playSys->playMode == PLAY_STS_FINISH ) {	/* RɋȂ̍ĐIH	*/

			/* ̍Đt@C擾	*/
			playSys->eepInfo.resume.mode = RESUME_NONE;
			if ( playList_moveNext( &playSys->playList ,playSys->eepInfo.repetMode ,0 ) ) {
				playSys->playMode = PLAY_STS_ACCESS_ERROR;
				strcpy_P( playSys->playInfo.text.textBuffer ,PSTR("SDJ[hANZXG[") );
				playSys->erroring = 1;
				update = 1;

			} else {
				update = 1;
				ret = player_play( PLAY_CURRENT );
				if ( ( ret != PLAY_STS_PLAYING ) && ( ret != PLAY_STS_NOT_SYPPORT ) ) {
					playSys->erroring = 1;
				} else {
					playSys->erroring = 0;
				}
			}
		}
	}

	/* G[̏ꍇ͍ĐXgEW[NA	*/
	if ( update && playSys->erroring ) {
		memset( &playSys->playList ,0x00 ,sizeof(PLAYLIST) );
		memset( &playSys->eepInfo.resume ,0x00 ,sizeof(playSys->eepInfo.resume) );
	}

	if ( update ) {
		return ( playSys->playMode );
	}

	return ( PLAY_STS_NONE );
}

/*****************************************************************************
*									ĐJn
* FPLAY_MODE mode	PLAY_CURRENT   : JgACe̍Đ(W[L)
*						PLAY_NEXT      : ̋ȂĐ
*						PLAY_BACK      : ŐȂĐ
* ߒlFPLAYER_STS      v[[Xe[^X
*****************************************************************************/
PLAYER_STS player_play( PLAY_MODE mode )
{
	uint16_t n;
	uint16_t t;

	/* Đ~							*/
	player_stop();

	/* JgACëړ			*/
	if ( ( mode == PLAY_NEXT ) || ( playSys->eepInfo.resume.mode == RESUME_NEXT ) ) {
		if ( playList_moveNext( &playSys->playList ,REPET_NONE ,0 ) ) {
			playSys->playMode = PLAY_STS_ACCESS_ERROR;
			playSys->eepInfo.resume.mode = RESUME_NONE;
			strcpy_P( playSys->playInfo.text.textBuffer ,PSTR("SDJ[hANZXG[") );
			return ( playSys->playMode );
		}
		playSys->eepInfo.resume.mode = RESUME_NONE;

	} else if ( mode == PLAY_BACK ) {
		if ( playList_moveBack( &playSys->playList ,REPET_NONE ,0 ) ) {
			playSys->playMode = PLAY_STS_ACCESS_ERROR;
			playSys->eepInfo.resume.mode = RESUME_NONE;
			strcpy_P( playSys->playInfo.text.textBuffer ,PSTR("SDJ[hANZXG[") );
			return ( playSys->playMode );
		}
		playSys->eepInfo.resume.mode = RESUME_NONE;
	}

	/* JgACet@C擾	*/
	if ( playList_getItemName( &playSys->playList ,0xff ,playSys->eepInfo.resume.fname ) != 0 ) {
		playSys->playMode = PLAY_STS_ACCESS_ERROR;
		playSys->eepInfo.resume.mode = RESUME_NONE;
		strcpy_P( playSys->playInfo.text.textBuffer ,PSTR("JgACej") );
		return ( playSys->playMode );
	}

	/* t@C擾						*/
	uint8_t ret = getPlayFileInfo( playSys->eepInfo.resume.fname ,&playSys->playInfo );
	if ( ret == 1 ) {
		playSys->playMode = PLAY_STS_ACCESS_ERROR;
		playSys->eepInfo.resume.mode = RESUME_NONE;
		sprintf_P( playSys->playInfo.text.textBuffer ,PSTR("̧ٵݴװ1 [%s]") ,playSys->playList.items[playSys->playList.index].fname );
		return ( playSys->playMode );

	} else if ( ret ) {
		playSys->playMode = PLAY_STS_NOT_SYPPORT;
		sprintf_P( playSys->playInfo.text.textBuffer ,PSTR("Ή̃t@CłB [%s]") ,playSys->playList.items[playSys->playList.index].fname );
		playSys->eepInfo.resume.mode = RESUME_NONE;
		return ( playSys->playMode );
	}

	/* t@CI[v						*/
	if ( f_open( &playSys->playFL ,playSys->eepInfo.resume.fname ,FA_READ ) != FR_OK ) {
		playSys->playMode = PLAY_STS_ACCESS_ERROR;
		playSys->eepInfo.resume.mode = RESUME_NONE;
		sprintf_P( playSys->playInfo.text.textBuffer ,PSTR("̧ٵݴװ2 [%s]") ,playSys->playList.items[playSys->playList.index].fname );
		return ( playSys->playMode );
	}

	/*														*/
	/* W[										*/
	/* MIDIĐ128{ŖړI̎Ԃ܂ōĐs	*/
	/* MIDIȊOłDSP@\ŖړĨt@CʒuփV[N	*/
	/*														*/
	if ( ( mode == PLAY_CURRENT ) && ( playSys->eepInfo.resume.mode == RESUME_SEEK ) ) {

		/* MIDȈꍇ128{[hŖړIʒu܂ōĐ	*/
		if ( playSys->playInfo.type == F_MIDI ) {
			vsRegWrite( SCI_DECODE_TIME ,0 );			/* DSP̍ĐԃWX^NA	*/
			vsRegWrite( SCI_DECODE_TIME ,0 );			/* 2񏑂ނƂŊmɃNA	*/
			vsWriteXmem( X_PLAYSPEED ,128 );			/* 128{Đ						*/
			t = (uint16_t)( playSys->eepInfo.resume.time / 100L );
			while ( playSys->playFL.fptr < playSys->playFL.fsize ) {
				wdt_reset();
				if ( f_forward( &playSys->playFL ,vsOutStream ,64 ,&n ) != FR_OK ) {
					playSys->playMode = PLAY_STS_ACCESS_ERROR;
					playSys->eepInfo.resume.mode = RESUME_NONE;
					strcpy_P( playSys->playInfo.text.textBuffer ,PSTR("V[NG[") );
					return ( playSys->playMode );
				}
				if ( t <= vsRegRead( SCI_DECODE_TIME ) ) {
					break;
				}
			}
			vsWriteXmem( X_PLAYSPEED ,1 );

		/* MIDIȊȌꍇ̓t@CV[N					*/
		} else {

			/* DoNotJumptONA܂Ńf[^𑗂*/
			/* DoNotJumpsv(MP3)̏ꍇ͉Ȃ	*/
			if ( playSys->playInfo.type & DO_NOT_JUMP_BIT ) {

				/* DoNotJumptONA܂łŃf[^𑗐M			*/
				do {
					if ( f_forward( &playSys->playFL ,vsOutStream ,64 ,&n ) != FR_OK ) {
						playSys->playMode = PLAY_STS_ACCESS_ERROR;
						playSys->eepInfo.resume.mode = RESUME_NONE;
						strcpy_P( playSys->playInfo.text.textBuffer ,PSTR("V[NG[") );
						return ( playSys->playMode );
					}
				} while ( ( playSys->playFL.fptr < playSys->playFL.fsize ) && ( vsRegRead( SCI_STATUS ) & 0x8000 ) );

				/* endFillByte 2052 o */
				uint8_t endFillByte = (uint8_t)( vsReadXmem( X_ENDFILLBYTE ) & 0x00ff );
				n = 2052;
				while ( n ) {
					wdt_reset();
					if ( vsOutFill( 0 ,0 ) != 0 ) {
						n -= vsOutFill( endFillByte ,n );
					}
				}
			}

			/* ubNTCYLȎ̓f[^E킹	*/
			if ( playSys->playInfo.blockSize != 0 ) {
				if ( playSys->eepInfo.resume.fpos > playSys->playInfo.startPos ) {
					uint32_t tmp = ( playSys->eepInfo.resume.fpos - playSys->playInfo.startPos ) / (uint32_t)playSys->playInfo.blockSize;
					playSys->eepInfo.resume.fpos = playSys->playInfo.startPos + ( tmp * (uint32_t)playSys->playInfo.blockSize );
				}
			}

			/* t@CV[N */
			if ( f_lseek( &playSys->playFL ,playSys->eepInfo.resume.fpos ) != FR_OK ) {
				playSys->playMode = PLAY_STS_ACCESS_ERROR;
				playSys->eepInfo.resume.mode = RESUME_NONE;
				strcpy_P( playSys->playInfo.text.textBuffer ,PSTR("V[NG[") );
				return ( playSys->playMode );
			}
		}
		playSys->playTime = playSys->eepInfo.resume.time;
		playSys->playTime10 = 0;

	/* 擪̍Đ				*/
	} else {
		playSys->playTime10 = 0;
		playSys->playTime = 0;
		playSys->eepInfo.playTimeDisable = 0;
	}

	/* ep[^Zbg					*/
	playSys->eepInfo.resume.mode = RESUME_NONE;
	playSys->tickPlayTime = 1;
	playSys->playMode = PLAY_STS_PLAYING;

	if ( !sys.mute && ( playSys->playTime == 0 ) ) {
		vsSetVolume( pgm_read_byte( &volumeTable[ eep.volume ] ) );
	}

	playSys->fileBlockSize = playSys->playFL.fsize / SEEK_VALUE_MAX;
	playSys->seekPos = playSys->playFL.fptr / playSys->fileBlockSize;
	playSys->backupSeekPos = 0xff;

	/* ݎݒ						*/
	TCNT0 = 0;
	if ( playSys->playInfo.type == F_PCM ) {
		OCR0A = 16;
		TCCR0B = 0x03;									/* F_CPU / 64		*/

	} else {
		OCR0A = 32;
		TCCR0B = 0x04;									/* F_CPU / 256		*/
	}

	PLAY_ISR_ENABLE();									/* Đ݋	*/

	return ( PLAY_STS_PLAYING );
}

/*****************************************************************************
*							Ȃ̍Đꎞf
* Fvoid
* ߒlFvoid
* ̊֐̓W[쐬čĐ~
*****************************************************************************/
void player_pause( void )
{
	/* DSP]荞݋֎~							*/
	PLAY_ISR_DISABLE();

	memset( &playSys->eepInfo.resume ,0x00 ,sizeof(playSys->eepInfo.resume) );

	if ( playSys->playMode & PLAY_STS_OPEN_BIT ) {

		playList_getItemName( &playSys->playList ,0xff ,playSys->eepInfo.resume.fname );
		playSys->eepInfo.resume.time = playSys->playTime;
		playSys->eepInfo.resume.fpos = playSys->playFL.fptr;

		if ( ( playSys->eepInfo.resume.fname[0] != '\0' ) && 
			 ( ( playSys->playMode == PLAY_STS_PLAYING ) ||
			   ( playSys->playMode == PLAY_STS_PAUSE   ) ||
			   ( playSys->playMode == PLAY_STS_FAINARAIZ ) ) ) {
			if ( playSys->playInfo.type == F_MIDI ) {
				uint32_t bytesLeft = vsReadXmemDword( X_BYTES_LEFT );
				if ( bytesLeft ) {
					playSys->eepInfo.resume.mode = RESUME_SEEK;
				} else {
					playSys->eepInfo.resume.mode = RESUME_TOP;
				}
			} else {
				playSys->eepInfo.resume.mode = RESUME_SEEK;
			}
		} else if ( playSys->playMode == PLAY_STS_FINISH ) {
			playSys->eepInfo.resume.mode = RESUME_NEXT;
		}
	}

	/* Đ~						*/
	player_stop();
	playSys->playMode = PLAY_STS_PAUSE;
}

/*****************************************************************************
*								Ȃ̍Đ~
* Fvoid
* ߒlFvoid
*****************************************************************************/
void player_stop( void )
{
	uint16_t data;

	/* DSP]荞݋֎~							*/
	PLAY_ISR_DISABLE();

	/* VS1053bZbg								*/
	vsResetPlayMode();
	vsSetVolume( 0 );
	vsHighPitchedSoundEmphasis( eep.hi_freq ,eep.hi_lv );
	vsBassEmphasis( eep.low_freq ,eep.low_lv );
	vsSetEarSpeaker( eep.earSpeaker );

	/* DSP]荞ݕϐNA					*/
	playSys->dspBusy = 0;									/* MIDIĐDSPrW[tO	*/
	playSys->endFillByte = 0;								/* endFillByte̒l				*/
	playSys->endFillByteCounter = 0;						/* MendFillByte ̐		*/

	/* DSPp[^WX^ޔϐNA			*/
	memset( (void *)sys.dsp_sp ,0x00 ,sizeof(sys.dsp_sp) );
	sys.dsp_hDat0 = 0;
	sys.dsp_hDat1 = 0;
	sys.dsp_auData = 0;
	sys.spTimer = 0;
	sys.sp_enable = 0;
	sys.fadeIn_timer = 0;

	/* t@CN[Y								*/
	if ( playSys->playMode & PLAY_STS_OPEN_BIT ) {
		f_close( &playSys->playFL );
	}

	/* DoNotJumptONA						*/
	data = vsRegRead( SCI_STATUS );
	data &= ~0x8000;
	vsRegWrite( SCI_STATUS ,data );

	playSys->playMode = PLAY_STS_STOP;
}

/*****************************************************************************
*								TEh
* FSOUND_TYPE type TEh^Cv
* ߒlFvoid
* ̊֐sDSP]݂֎~
*****************************************************************************/
void player_sound( SOUND_TYPE type )
{
	/* DSP]荞݋֎~		*/
	PLAY_ISR_DISABLE();

	switch ( type ) {
		case SOUND_LOWBATT:						/* obe[dቺVbg_E	*/
			vsBeep( 880 ,3 ,80 );
			break;

		case SOUND_ALERT:						/* obe[dቺx			*/
			vsBeep( 880 ,2 ,150 );
			break;

		case SOUND_ERROR:						/* VXeG[					*/
			vsBeep( 220  ,1 ,250 );
			break;

		case SOUND_POWER_ON:					/* dON							*/
			vsBeep( 1680 ,1 ,75 );
			vsBeep( 880 ,1 ,75 );
			break;

		case SOUND_POWER_OFF:					/* dOFF							*/
			vsBeep( 880 ,1 , 75 );
			vsBeep( 1680 ,1 , 75 );
			break;

		case SOUND_NEXT_MUSIC:					/* ̋							*/
			vsBeep( 3000 ,2 ,60 );
			break;

		case SOUND_BACK_MUSIC:					/* Ő							*/
			vsBeep( 3000 ,2 ,60 );
			break;

		case SOUND_TOP_OF_MUSIC:				/* Đ̋Ȃ̐擪ɖ߂			*/
			vsBeep( 3000 ,1 ,60 );
			break;

		case SOUND_PAUSE:						/* |[Y							*/
			vsBeep( 1680 ,1 ,60 );
			break;

		case SOUND_CHANGE_MODE:					/* v[[EWI[hؑւ̉	*/
			vsBeep( 2000 ,2 ,60 );
			break;

		case SOUND_CHANGE_STATION:				/* FMWIǕύX̉			*/
			vsBeep( 1200 ,1 ,60 );
			break;

		case SOUND_SEEK_START:					/* FMWIXLJn̉	*/
			vsBeep( 1200 ,2 ,60 );
			break;

		default:
			break;
	}
}

